/*global wc_setup_params */
/*global wc_setup_currencies */
/*global wc_base_state */
jQuery( function( $ ) {
	function blockWizardUI() {
		$('.wc-setup-content').block({
			message: null,
			overlayCSS: {
				background: '#fff',
				opacity: 0.6
			}
		});
	}

    $('.nasil-yapilir').on('click',function(e){
		$( this ).WCBackboneModal( {
			template: 'wc-modal-tracking-setup'
        } );
        e.preventDefault();
    });

    $(document).on('click','.modal_kapat',function(e){
		$('.modal-close').trigger('click');
        e.preventDefault();
    });

	$(document).on( 'click','.button-next', function() {
		var form = $( this ).parents( 'form' ).get( 0 );

		if ( ( 'function' !== typeof form.checkValidity ) || form.checkValidity() ) {
			blockWizardUI();
		}
	} );

	$( 'form.address-step' ).on( 'submit', function( e ) {
		var form = $( this );
		if ( ( 'function' !== typeof form.checkValidity ) || form.checkValidity() ) {
			blockWizardUI();
		}

		$('.wc-setup-content').unblock();

		$( document.body ).on( 'wc_backbone_modal_response', function() {
			form.unbind( 'submit' ).submit();
		} );

		$( '#wc_tracker_checkbox_dialog' ).on( 'change', function( e ) {
			var eventTarget = $( e.target );
			$( '#wc_tracker_checkbox' ).prop( 'checked', eventTarget.prop( 'checked' ) );
		} );

		$( '#wc_tracker_submit' ).on( 'click', function () {
			form.unbind( 'submit' ).submit();
		} );

		return true;
	} );

	/* Setup postcode field and validations */
	$( '#store_country' ).on( 'change', function() {
		if ( ! wc_setup_params.postcodes ) {
			return;
		}

		var $this                 = $( this ),
			country               = $this.val(),
			$store_postcode_input = $( '#store_postcode' ),
			country_postcode_obj  = wc_setup_params.postcodes[ country ];

		// Default to required, if its unknown whether postcode is required or not.
		if ( $.isEmptyObject( country_postcode_obj ) || country_postcode_obj.required  ) {
			$store_postcode_input.attr( 'required', 'true' );
		} else {
			$store_postcode_input.removeAttr( 'required' );
		}
	} );

	$( '#store_country' ).change();

	$( '.wc-wizard-services' ).on( 'change', '.wc-wizard-service-enable input', function() {
		if ( $( this ).is( ':checked' ) ) {
			$( this ).closest( '.wc-wizard-service-toggle' ).removeClass( 'disabled' );
			$( this ).closest( '.wc-wizard-service-item' ).addClass( 'checked' );
			$( this ).closest( '.wc-wizard-service-item' )
				.find( '.wc-wizard-service-settings' ).removeClass( 'hide' );
		} else {
			$( this ).closest( '.wc-wizard-service-toggle' ).addClass( 'disabled' );
			$( this ).closest( '.wc-wizard-service-item' ).removeClass( 'checked' );
			$( this ).closest( '.wc-wizard-service-item' )
				.find( '.wc-wizard-service-settings' ).addClass( 'hide' );
		}
	} );

	$( '.wc-wizard-services' ).on( 'keyup', function( e ) {
		var code = e.keyCode || e.which,
			$focused = $( document.activeElement );

		if ( $focused.is( '.wc-wizard-service-toggle, .wc-wizard-service-enable' ) && ( 13 === code || 32 === code ) ) {
			$focused.find( ':input' ).click();
		}
	} );

	$( '.wc-wizard-services' ).on( 'click', '.wc-wizard-service-enable', function( e ) {
		var eventTarget = $( e.target );

		if ( eventTarget.is( 'input' ) ) {
			e.stopPropagation();
			return;
		}

		var $checkbox = $( this ).find( 'input[type="checkbox"]' );

		$checkbox.prop( 'checked', ! $checkbox.prop( 'checked' ) ).change();
	} );

	$( '.wc-wizard-services-list-toggle' ).on( 'click', function() {
		$( this ).closest( '.wc-wizard-services-list-toggle' ).toggleClass( 'closed' );
		$( this ).closest( '.wc-wizard-services' ).find( '.wc-wizard-service-item' )
			.slideToggle()
			.css( 'display', 'flex' );
	} );

	$( '.wc-wizard-services' ).on( 'change', '.wc-wizard-shipping-method-select .method', function( e ) {
		var zone = $( this ).closest( '.wc-wizard-service-description' );
		var selectedMethod = e.target.value;

		var description = zone.find( '.shipping-method-descriptions' );
		description.find( '.shipping-method-description' ).addClass( 'hide' );
		description.find( '.' + selectedMethod ).removeClass( 'hide' );

		var $checkbox = zone.parent().find( 'input[type="checkbox"]' );
		var settings = zone.find( '.shipping-method-settings' );
		settings
			.find( '.shipping-method-setting' )
			.addClass( 'hide' )
			.find( '.shipping-method-required-field' )
			.prop( 'required', false );
		settings
			.find( '.' + selectedMethod )
			.removeClass( 'hide' )
			.find( '.shipping-method-required-field' )
			.prop( 'required', $checkbox.prop( 'checked' ) );
	} ).find( '.wc-wizard-shipping-method-select .method' ).change();

	$( '.wc-wizard-services' ).on( 'change', '.wc-wizard-shipping-method-enable', function() {
		var checked = $( this ).is( ':checked' );
		var selectedMethod = $( '.wc-wizard-shipping-method-select .method' ).val();

		$( this )
			.closest( '.wc-wizard-service-item' )
			.find( '.' + selectedMethod )
			.find( '.shipping-method-required-field' )
			.prop( 'required', checked );
	} );

	$('#wooKategori').on('select2:select',function(){
		$('#n11_1').select2('open');
	});

	$('#n11_1').on('select2:select',function(){
		var anaKat = $(this).val();
		var data = {
			action : 'n11_1_kategori_ajax',
			_nonce : wc_setup_params.entego_kategori_nonce,
			value : anaKat
		}
		blockWizardUI();

		$.ajax({
			url:wc_setup_params.ajax_url,
			method:'post',
			data:data,
			dataType:'json',
			success:function(cvp){
				if(cvp.sonuc == 'ok'){
					$('#n11_2').html('').select2({data: [{id: '', text: 'Seçim Yapınız'}]});
					$('#n11_3').html('').select2({data: [{id: '', text: 'Üst Kategori seçiniz'}]});
					$('#n11_4').html('').select2({data: [{id: '', text: 'Üst Kategori seçiniz'}]});

					$.each(cvp.kategoriler,function(i,val){
						var newOption = new Option(val.name, val.id+"-"+val.name, false, false);
						$('#n11_2').append(newOption).trigger('change');
					});
					$('#n11_2').select2('open');
				}else {
					alert(cvp.mesaj);
				}
			},
			error:function(eror){
				alert('Bilinmeyen bir bağlantı hatası oluştu, daha sonra tekrar deneyiniz');
			},
			complete:function(){
				$('.wc-setup-content').unblock();
			}
		})
	});

	$('#n11_2').on('select2:select',function(){
		var anaKat = $(this).val();
		var data = {
			action : 'n11_1_kategori_ajax',
			_nonce : wc_setup_params.entego_kategori_nonce,
			value : anaKat
		}
		blockWizardUI();

		$.ajax({
			url:wc_setup_params.ajax_url,
			method:'post',
			data:data,
			dataType:'json',
			success:function(cvp){
				if(cvp.sonuc == 'ok'){
					if($(cvp.kategoriler).length > 0){
						var text = 'Seçim Yapınız';
						$('#n11_3').html('').select2({data: [{id: '', text: text}]}).prop('disabled',false).prop('required',true);
						$('#n11_4').html('').select2({data: [{id: '', text: 'Üst Kategori seçiniz'}]}).prop('disabled',true).prop('required',true);
					}else{
						var text = 'Alt Kategori Bulunmuyor';
						$('#n11_3').html('').select2({data: [{id: '', text: text}]}).prop('required',false).prop('disabled',true);
						$('#n11_4').html('').select2({data: [{id: '', text: text}]}).prop('required',false).prop('disabled',true);
					}

					$.each(cvp.kategoriler,function(i,val){
						var newOption = new Option(val.name, val.id+"-"+val.name, false, false);
						$('#n11_3').append(newOption).trigger('change');
					});
					if(cvp.kategoriler != null){
						$('#n11_3').select2('open');
					}
				}else {
					alert(cvp.mesaj);
				}
			},
			error:function(eror){
				alert('Bilinmeyen bir bağlantı hatası oluştu, daha sonra tekrar deneyiniz');
			},
			complete:function(){
				$('.wc-setup-content').unblock();
			}
		})
	});

	$('#n11_3').on('select2:select',function(){
		var anaKat = $(this).val();
		var data = {
			action : 'n11_1_kategori_ajax',
			_nonce : wc_setup_params.entego_kategori_nonce,
			value : anaKat
		}
		blockWizardUI();

		$.ajax({
			url:wc_setup_params.ajax_url,
			method:'post',
			data:data,
			dataType:'json',
			success:function(cvp){
				if(cvp.sonuc == 'ok'){
					if($(cvp.kategoriler).length > 0){
						var text = 'Seçim Yapınız';
						$('#n11_4').html('').select2({data: [{id: '', text: text}]}).prop('disabled',false).prop('required',true);
					}else{
						var text = 'Alt Kategori Bulunmuyor';
						$('#n11_4').html('').select2({data: [{id: '', text: text}]}).prop('required',false).prop('disabled',true);
					}


					$.each(cvp.kategoriler,function(i,val){
						var newOption = new Option(val.name, val.id+"-"+val.name, false, false);
						$('#n11_4').append(newOption).trigger('change');
					});

					if(cvp.kategoriler != null){
						$('#n11_4').select2('open');
					}
				}else {
					alert(cvp.mesaj);
				}
			},
			error:function(eror){
				alert('Bilinmeyen bir bağlantı hatası oluştu, daha sonra tekrar deneyiniz');
			},
			complete:function(){
				$('.wc-setup-content').unblock();
			}
		})
	});

	$('#urun').select2();

	$('#urun').on('select2:select',function(){
		var id = $(this).val();
		blockWizardUI();
		var data = {
			action:'entego_setup_urun_bilgileri',
			id:id,
			nonce:wc_setup_params.entego_urun_bilgileri
		};

		$.ajax({
			url:wc_setup_params.ajax_url,
			method:'post',
			data:data,
			dataType:'json',
			success:function(cvp){
				if(cvp.sonuc){
					$('.content').html(cvp.content);
				}else{
					alert(cvp.mesaj);
				}
				console.log(cvp);
			},error:function(){
				alert(wc_setup_params.urunBilgileriHata);
			},complete:function(){
				$('.wc-setup-content').unblock();
			}
		});
	});

	$('form.emailBulten').on('submit',function(e){
		blockWizardUI();
		var mail = $('input[name="email"]').val();
		var url = $(this).data('url');
		var nonce = $(this).find('input#nonce').val();
		if(mail == ''){
			$('.wc-setup-content').unblock();
			alert('E-Mail Alanı boş bırakılamaz.');
		}else {
			var data = {
				action: 'n11_mail_abonelik_kaydi',
				gizliAnahtar: nonce,
				mail: mail,
			};
			$.ajax({
				method:'post',
				data:data,
				url:url,
				dataTyoe:'json',
				success:function(cvp){
					if(cvp.sonuc){
						alert('Kayıt Başarılı.');
						$('.emailBulten input, .emailBulten button').prop('disabled',true);
						$(e).hide('300');
					}else {
						alert(cvp.mesaj);
					}
				},error:function(){
					alert('Bilinmeyen bir bağlantı hatası gerçekleşti.');
				},
				complete:function(){
					$('.wc-setup-content').unblock();
				}
			});
		}

		e.preventDefault();
	});
} );
