<?php
//Bu dosya doğrudan çağrılırsa iptal edin.
if ( ! defined( 'WPINC' ) ) {
	die;
}
/**
 * Eklenti için yönetici alanı görünümü sağlama
 *
 * Bu dosya, eklentinin yöneticiye bakan yönlerini işaretlemek için kullanılır.
 *
 * @since      1.0.0
 *
 * @package    Entoge_N11
 * @subpackage Entego_N11/admin/partials
 */
$key        = get_option('entego_n11_api_key');
$key2      = get_option('entego_n11_api_secret_key');
$entego_key = get_option('entego_n11_key');
$response = Entego_N11_Baglanti::HTTPPost("sablonGonder", array(
'api_key' => $key,
'api_secret_key' => $key2,
'alan_adi'	=> get_site_url(),
'entego_key' => $entego_key,
));
$response = json_decode($response);
if(get_option('entego_n11_uyelik_bitis_hatirlatma') ){
    entego_n11_uyelik_bitis_notu(get_option('entego_n11_uyelik_bitis_tarih'), get_option('entego_n11_uyelik_kredi'));
}
if(get_option('entego_n11_deneme_uyelik')){
?>
 <div class="notice is-dismissible">
    <p><?php esc_html_e('Entego N11 WooCommerce eklentisinin deneme üyeliğini kullanmaktasınız.','entego-n11')?>
</div>
<?php
}
?>

<!-- Bu dosya öncelikle biraz PHP içeren HTML'den oluşmalıdır. -->
<form method="post" id="entegoAyarlar" action="<?php echo admin_url( 'admin-ajax.php' ); ?>">
<table class="form-table">
    <tbody>
        <tr valign="top">
            <th scope="row" class="titledesc">
                <label for="entego_api"><?=esc_html('Entego API Anahtarı','entego-n11')?><span class="entego_n11-help-tip"></span></label>
            </th>
            <td class="forminp forminp-text">
                <input name="entego_api" id="entego_api" type="text" style="" value="<?php echo get_option('entego_n11_key');?>" class="ayarlarForm" placeholder="" disabled>
            </td>
        </tr>
        <tr valign="top">
            <?php
            if($tarih = $response->uyelikBitisTarihi){
                $bitis_tarih = date('Y-m-d',$tarih);
                $bitis_tarih = new DateTime($bitis_tarih);
                $tarih = new DateTime(date("Y-m-d"));
                $interval= $tarih->diff($bitis_tarih);
                $gun = (int)$interval->format("%r%a");
                if($response->uyelikBitisTarihi=='' || $gun<0){
            ?>
            <th scope="row" class="titledesc">
                <label for="entego_n11_kredi"><?=esc_html('Kalan Kullanım Kredisi','entego-n11')?><span class="entego_n11-help-tip"></span></label>
            </th>
            <td class="forminp forminp-text">
                <input name="entego_n11_kredi" id="entego_n11_kredi" type="text" style="" value="<?php echo $response->kredi;?>" class="ayarlarForm" placeholder="" disabled>
                <p style="font-size:11px;margin-left:2px;"><?=esc_html('Satın almak için sitemizi ziyaret ediniz. ','entego-n11')?><a target="_blank" href="https://entego.com.tr"><?=esc_html('Entego\'ya Git','entego-n11')?></a></p>
            </td>
            <?php
                }else {
            ?>
            <th scope="row" class="titledesc">
                <label for="entego_n11_kredi"><?=esc_html('Üyelik Bitiş Tarihi','entego-n11')?><span class="entego_n11-help-tip"></span></label>
            </th>
            <td class="forminp forminp-text">
                <input name="entego_n11_kredi" id="entego_n11_kredi" type="text" style="" value="<?php echo date('d/m/Y',$response->uyelikBitisTarihi);?>" class="ayarlarForm" placeholder="" disabled>
                <p style="font-size:11px;margin-left:2px;"><?=esc_html('Üyelik Sürenizi uzatmak için internet sitemizi ziyaret ediniz. ','entego-n11')?><a target="_blank" href="https://entego.com.tr"><?=esc_html('Entego\'ya Git','entego-n11')?></a></p>
            </td>
            <?php
                }
            }else {
            ?>
            <th scope="row" class="titledesc">
                <label for="entego_n11_kredi"><?=esc_html('Kalan Kullanım Kredisi','entego-n11')?><span class="entego_n11-help-tip"></span></label>
            </th>
            <td class="forminp forminp-text">
                <input name="entego_n11_kredi" id="entego_n11_kredi" type="text" style="" value="<?php echo $response->kredi;?>" class="ayarlarForm" placeholder="" disabled>
                <p style="font-size:11px;margin-left:2px;"><?=esc_html('Satın almak için sitemizi ziyaret ediniz. ','entego-n11')?><a target="_blank" href="https://entego.com.tr"><?=esc_html('Entego\'ya Git','entego-n11')?></a></p>
            </td>
            <?php
            }
            ?>
        </tr>

        <tr valign="top">
            <th scope="row" class="titledesc">
                <label for="entego_n11_api"><?=esc_html('N11 API Anahtarı','entego-n11')?> <span class="entego_n11-help-tip"></span></label>
            </th>
            <td class="forminp forminp-text">
                <input name="entego_n11_api" id="entego_n11_api" type="text" style="" value="<?php echo get_option('entego_n11_api_key');?>" class="ayarlarForm" placeholder="" required>
            </td>
        </tr>

        <tr valign="top">
            <th scope="row" class="titledesc">
                <label for="entego_n11_api_secret"><?=esc_html('N11 API Şifresi','entego-n11')?><span class="entego_n11-help-tip"></span></label>
            </th>
            <td class="forminp forminp-text">
                <input name="entego_n11_api_secret" id="entego_n11_api_secret" type="text" style="" value="<?php echo get_option('entego_n11_api_secret_key');?>" class="ayarlarForm" placeholder="" required>
            </td>
        </tr>
        
        <tr valign="top">
            <th scope="row" class="titledesc">
                <label for="entego_n11_sablon"><?=esc_html('Varsayılan Teslimat Şablonu Seçiniz','entego-n11')?><span class="entego_n11-help-tip"></span></label>
            </th>
            <td class="forminp forminp-text">
                <select class="ayarlarForm" value="<?=get_option('n11_varsayilan_sablon')?>" name="entego_n11_sablon" id="entego_n11_sablon">
                     <?php
                        $vSablon = get_option("n11_varsayilan_sablon");
                        if($entego_key == ''){
                            echo  '<option value="">'.esc_html('Sistem kaydı gerçekleşmemiş api anahtarınızı ve şifrenizi girin doğrulayın.','entego-n11').'</option>';
                        }elseif($response == ''){
                            echo  '<option value="">'.esc_html('Entegoya ulaşılamıyor, daha sonra tekrar deneyiniz.','entego-n11').'</option>';
                        }elseif($entego_key != ''){
                            if($response->sonuc){
                                if(count($response->sablon)<1){
                                    echo  '<option value="">'.esc_html('N11 Mağaza Panelinizden Teslimat Adresi Şablonu Oluşturmalısınız.','entego-n11').'</option>';
                                }else {
                                    echo  '<option value="">'.esc_html('Varsayılan seçiniz.','entego-n11').'</option>';
                                    foreach($response->sablon as $temp){
                                        if($vSablon == $temp->templateName){$select=' selected';}else{$select=null;}
                                        echo '<option value="'.$temp->templateName.'"'.$select.'>'.$temp->templateName.'</option>';
                                    }
                                }
                            }else {
                                echo  '<option value="">'.$sablon->mesaj.'</option>';
                            }
                        }else {
                            echo  '<option value="">'.esc_html('Öncelikle Api Key ve Api Secret Key Girmelisiniz.','entego-n11').'</option>';
                        }
                    ?>
                </select>
            </td>
        </tr>

        <tr valign="top">
            <th scope="row" class="titledesc">
                <label for="teslimat_suresi"><?=esc_html('Varsayılan Kargo Teslimat Süresi','entego-n11')?><span class="entego_n11-help-tip"></span></label>
            </th>
            <td class="forminp forminp-text">
                <input name="teslimat_suresi" id="teslimat_suresi" type="number" style="" value="<?php echo get_option('entego_n11_kargo_suresi');?>" class="ayarlarForm" placeholder="<?=esc_html('Kargo Teslimat Süresini giriniz.','entego-n11')?>">
            </td>
        </tr>

        <tr valign="top">
            <th scope="row" class="titledesc">
                <label for="varsayilan_autosave"><?=esc_html('Eklenen ürünlerin Otomatik Güncellemesi','entego-n11')?><span class="entego_n11-help-tip"></span></label>
            </th>
            <td class="forminp forminp-text">
                <select class="ayarlarForm" name="varsayilan_autosave" id="varsayilan_autosave">
                    <?php $value = get_option('entego_n11_autosave',true);?>
                    <option value="" <?php if($value==''){echo 'selected';} ?>><?=esc_html('Seçim Yapınız','entego-n11')?></option>
                    <option value="true" <?php if($value=='true'){echo 'selected';}?>><?=esc_html('Otomatik Gönderme Açık','entego-n11')?></option>
                    <option value="false" <?php if($value=='false'){echo 'selected';}?>><?=esc_html('Otomatik Gönderme Kapalı','entego-n11')?></option>
                </select>
            </td>
        </tr>

    </tbody>
    </table>

    <p class="submit">
        <button name="save" class="button-primary entego_n11-save-button" type="submit" value="<?=esc_html('Değişiklikleri kaydet','entego-n11')?>"><?=esc_html('Değişiklikleri kaydet','entego-n11')?></button>
    </p>
</form>