<?php
//Bu dosya doğrudan çağrılırsa iptal edin.
if ( ! defined( 'WPINC' ) ) {
	die;
}
	class Entego_N11_Urun_Ekle_Row{
		public function __construct(){}

		public function add(){
			add_filter('post_row_actions', array($this, 'entego_n11_urun_gonder'), 10, 2);
			add_filter('bulk_actions-edit-product', array($this, 'entego_n11_toplu_urun_gonder'));
			add_filter( 'handle_bulk_actions-edit-product', array($this,'entego_n11_toplu_urun_gonder_post'), 10, 3 );
			add_action( 'admin_notices', array($this,'entego_n11_toplu_urun_gonder_post_uyari') );
			add_action( 'add_meta_boxes', array( $this, 'add_meta_box' ) );
			add_action( 'woocommerce_product_after_variable_attributes', array( $this, 'varyasyon_meta_box' ), 10, 3 );
			add_action( 'woocommerce_product_options_general_product_data', array( $this, 'basit_urun_meta_box' ), 10, 3 );
			add_action( 'save_post_product', array( $this, 'basit_urun_kaydet' ), 10, 3 );
			add_action( 'woocommerce_save_product_variation', array( $this, 'varyasyonlu_urun_kaydet' ), 10, 2 );
			add_action( 'save_post_product', array($this,'otomatik_guncelleme'), 10, 3);
			add_action( 'woocommerce_update_product_variation', array($this,'otomatik_guncelleme_varyasyon'), 10, 1);

			// Tüm Ürünler Sayfası Filtre
			add_filter( 'restrict_manage_posts',array($this,'n11_filitreleri'),10,2);
			add_filter( 'pre_get_posts',array($this,'n11_filitreleri_goruntule'),10,2);

			// Tüm Ürünler Sayfası Table Add Columns
			add_filter( 'manage_edit-product_columns',array($this,'tablo_ekle_column_1'));
			add_action( 'manage_product_posts_custom_column', array($this,'tablo_ekle_column_2'), 10, 2 );

			// Footer Bölümü Hook
			add_filter( 'admin_footer_text', array($this,'footer_duzenle'),11 );
			add_filter( 'update_footer',     array($this,'footer_duzenle_update'), 11 );


   			add_action('admin_enqueue_scripts', array($this, 'load_js'));
   			add_action('wp_ajax_entego_n11_urun_ekle', array($this, "entego_n11_urun_ekle"));
   			add_action('wp_ajax_entego_n11_urun_ekle_simple', array($this, "entego_n11_urun_ekle_simple"));
			add_action( 'wp_ajax_kategori_esle_ajax', array( $this, 'kategori_esle') );
			add_action( 'wp_ajax_entego_n11_urun_sil', array( $this, 'n11_urun_sil') );
			add_action("wp_ajax_urun_satin_alma_not_ekle",array($this,'urunNotEkle'));
			add_action("wp_ajax_sonuclar_n11_kategori_kaydet",array($this,'sonuclar_kategori_ekle'));
			add_action("wp_ajax_sonuclar_ozellikler_getir",array($this,'ozellik_gonder'));
			add_action("wp_ajax_nitelik_kayit_form",array($this,'nitelik_guncelle'));
			add_action("wp_ajax_sonuclar_hata_sil",array($this,'sonuclarHataSil'));
			add_action( 'wp_ajax_entego_setup_urun_bilgileri', array($this, 'urun_bilgileri_ajax' ) );
			add_action( 'wp_ajax_entego_n11_sonuc_tekrar_siraya_al', array($this, 'sonuclar_ajax_tekrar_siraya_al' ) );
			add_action("wp_ajax_entego_n11_urun-kategori-kaldir",array($this,'urunKategoriEslestirmeKaldir'));
			add_action("wp_ajax_entego_n11_kategori_ara", array($this,'ajax_kategori_sorgula'));
			add_action("wp_ajax_entego_n11_urun_kaydetme",array($this, 'entego_n11_urun_kaydetme'));
			add_action("wp_ajax_entego_n11_marka_sil",array($this, 'entego_n11_marka_sil'));
		}

		/**
		 * WooCommerce Ürünler Sayfası Ürün Gönderme Linki Ekleme
		 */
		public function entego_n11_urun_gonder($actions, $post){
			if($post->post_type == 'product'){
				$kategori = get_post_meta($post->ID,'n11Kategori_id');
				if(isset($kategori[0])){
					if(get_post_meta($post->ID,'n11urunId',false)){
						$actions['n11_urun_gonder'] = '<a data-id="'.$post->ID.'" data-url="'.admin_url( 'admin-ajax.php' ).'" data-nonce="'.wp_create_nonce('urun_ekle_'.$post->ID).'" class="entegoN11UrunGonder" style="cursor:pointer;">' . __('N11\'de Ürünü Güncelle','entego-n11') . '</a>';
					}else {
						$actions['n11_urun_gonder'] = '<a data-id="'.$post->ID.'" data-url="'.admin_url( 'admin-ajax.php' ).'" data-nonce="'.wp_create_nonce('urun_ekle_'.$post->ID).'" class="entegoN11UrunGonder" style="cursor:pointer;">' . __('Ürünü N11\'e Gönder','entego-n11') . '</a>';
					}
				}else {
					$actions['n11_kategori_esle'] = '<a href="'.admin_url('post.php?post='.$post->ID.'&action=edit"').' style="cursor:pointer;">' . __('N11 Kategorisi Eşleştir') . '</a>';
				}
				return $actions;
			}
		}

		/**
		 * WooCommerce Ürünler Sayfası Toplu Ürün Gönderme Linki Ekleme
		 */
		public function entego_n11_toplu_urun_gonder($actions){
			$actions['n11_toplu_gonder'] = __( 'N11\'e Gönder', 'entego-n11');
			$actions['n11_toplu_sil'] = __( 'N11\'den Sil', 'entego-n11');
			$actions['n11_auto_update_ac'] = __( 'N11 Otomatik Güncelleme Aç', 'entego-n11');
			$actions['n11_auto_update_kapat'] = __( 'N11 Otomatik Güncelleme Kapat', 'entego-n11');
			return $actions;
		}
 
		/**
		 * WooCommerce Ürünler Sayfası Ürün Gönderme Post İşlemi
		 */
		public function entego_n11_toplu_urun_gonder_post( $redirect_to, $doaction, $post_ids ) {
			if ( $doaction == 'n11_toplu_gonder' ) {
				$toplam = count($post_ids);
				if($toplam > 0){
					foreach($post_ids as $id){
						$sonuc = $this->cronUrun($id);
						if(!$sonuc){
							$this->cronUrunEkle($id);
						}
					}
					$redirect_to = add_query_arg( 'n11_toplu_gonder_sonuc',$toplam, $redirect_to );
				}
				return $redirect_to;
			}elseif ( $doaction == 'n11_toplu_sil' ) {
				$toplam = count($post_ids);
				if($toplam > 0){
					foreach($post_ids as $id){
						$this->urun_sil($id);
					}
					$redirect_to = add_query_arg( 'n11_toplu_sil_sonuc',$toplam, $redirect_to );
				}
				return $redirect_to;
			}elseif($doaction == 'n11_auto_update_ac'){
				//Toplu İşlemler Otomatik Güncelleme Aç
				$this->urunAutoUpdate($post_ids,'true');
				$redirect_to = add_query_arg( 'n11_auto_update','autoOn', $redirect_to );
				return $redirect_to;

			}elseif($doaction == 'n11_auto_update_kapat'){
				// Toplu İşlemler Otomatik GÜncelleme Kapat
				$this->urunAutoUpdate($post_ids,'false');
				$redirect_to = add_query_arg( 'n11_auto_update', 'autoOff', $redirect_to );
				return $redirect_to;
			}
		}

		/**
		 * Toplu İşlemler Ürünü Otomatik Güncelle Açma ve Kapama
		 * 
		 */
		public function urunAutoUpdate($ids,$islem){
			foreach($ids as $id){
				update_post_meta($id,'urunN11OtomatikGuncelle',$islem);
			}
		}
			
		/**
		 * Admin Notices HOOK
		 * 
		 */
		public function entego_n11_toplu_urun_gonder_post_uyari() {
			if ( ! empty( $_REQUEST['n11_toplu_gonder_sonuc'] )) {

				$toplam = $_REQUEST['n11_toplu_gonder_sonuc'];
				printf( '<div id="message" class="updated notice is-dismissible"><p>' .
				_n( 'Seçmiş olduğunuz ürün sıraya alındı. İşlem sonucunu eklentinin <a href="'.admin_url("admin.php?page=entego_n11_sonuclar").'">sonuçlar</a> sayfasından takip edebilirsiniz.',
				'Seçmiş olduğunuz ürünler sıraya alındı. İşlemlerin sonucu eklentinin <a href="'.admin_url("admin.php?page=entego_n11_sonuclar").'">sonuçlar</a> sayfasından takip edebilirsiniz. 
				<br><strong>İşlem yapılan ürünleri sayısı: %s </strong>',
				$toplam
				) .'</p></div>', $toplam);

			}elseif ( ! empty( $_REQUEST['n11_toplu_sil_sonuc'] )) {

				$toplam = $_REQUEST['n11_toplu_sil_sonuc'];
				printf( '<div id="message" class="updated notice is-dismissible"><p>' .
				_n( 'Seçmiş olduğunuz ürün silindi.',
				'Seçmiş olduğunuz ürünler silindi. 
				<br><strong>İşlem yapılan ürünleri sayısı: %s </strong>',
				$toplam
				) .'</p></div>', $toplam);

			}elseif(! empty( $_REQUEST['n11_urun_edit_uyari'] )){
				$n11_cevap = intval( $_REQUEST['n11_urun_edit_uyari'] );
				echo '<div id="message" class="updated notice fade is-dismissible"><p>'.$n11_cevap.'</p></div>';
			}elseif(! empty( $_REQUEST['n11_auto_update'] )){
				$n11_cevap = sanitize_text_field($_REQUEST['n11_auto_update']);
				if($n11_cevap == 'autoOn'){
					$cevap = esc_html('Seçmiş olduğunuz ürünlerin otomatik güncellemesi açıldı.','entego-n11');
				}elseif($n11_cevap == 'autoOff') {
					$cevap = esc_html('Seçmiş olduğunuz ürünlerin otomatik güncellemesi kapatıldı.','entego-n11');
				}
				echo '<div id="message" class="updated notice fade is-dismissible"><p>'.$cevap.'</p></div>';
			}
		}

		/**
		 * Ürünler Sayfasından N11'e gönder butonu HOOK
		 * 
		 */
		public function entego_n11_urun_ekle(){
            $id = sanitize_text_field($_POST['id']);
			if(wp_verify_nonce(sanitize_text_field($_POST["nonce"]),'entego_n11_urun_ekle') && isset($id)){
				$gonder = $this->urun_gonder($id)[0];
				if($gonder->result->status == "success"){
					wp_send_json(array(
						'success'=>true,
						'mesaj'=>esc_html('Ürün Başarıyla N11\'e gönderildi.','entego-n11'),
						'urunSonuc'=>$gonder->product
					));
				}else {
					if(isset($gonder->result->errorMessage)){
						$sonuc = str_replace(array('product','stockItem','subTitle'), array(esc_html('Ürün','entego-n11'),esc_html('Varyasyon','entego-n11'),esc_html('Kısa Açıklama','entego-n11')), $gonder->result->errorMessage);
					}else {
						$sonuc = $gonder;
					}
					wp_send_json(array(
						'success'=>false,
						'mesaj'=>$sonuc,
						'urunSonuc'=>$gonder
					));
				}
			}else{
				wp_send_json(array('success'=>false, 'mesaj'=>esc_html('AJax Doğrulaması gerçekleşmedi.','entego-n11')));
			}
		}

		/**
		 * Ürünler Sayfasından N11'e gönder butonu HOOK
		 * 
		 */
		public function entego_n11_urun_ekle_simple(){
            $id = sanitize_text_field($_POST['id']);
			if(wp_verify_nonce(sanitize_text_field($_POST["nonce"]),'entego_n11_urun_ekle') && isset($id)){
				$gonder = $this->urun_gonder($id)[0];
				if($gonder->result->status == "success"){
					wp_send_json(array(
						'success'=>true,
						'mesaj'=>esc_html("Ürün Başarıyla N11'e gönderildi.",'entego-n11'),
						'urunSonuc'=>$gonder->product
					));
				}else {
					if(isset($gonder->result->errorMessage)){
						$sonuc = str_replace(array('product','stockItem','subTitle'), array(esc_html('Ürün','entego-n11'),esc_html('Varyasyon','entego-n11'),esc_html('Kısa Açıklama','entego-n11')), $gonder->result->errorMessage);
					}else {
						$sonuc = $gonder;
					}
					wp_send_json(array(
						'success'=>false,
						'mesaj'=>$sonuc,
						'urunSonuc'=>$gonder
					));
				}
			}else{
				wp_send_json(array('success'=>false, 'mesaj'=>esc_html('AJax Doğrulaması gerçekleşmedi.','entego-n11')));
			}
		}

		/**
		 * Ürünler Sayfasına JS Dosyalarını import Etme
		 */
		public function load_js(){

			wp_enqueue_script('entego-n11-column-js', plugins_url("entego-n11/admin/js/entego-n11-urun-gonder.js"), array("jquery-effects-slide",'select2-js','selectWoo-js'), time(), true);
			wp_localize_script( 'entego-n11-column-js', 'entego_n11_urun_gonder', array(
				'ajax_url' => admin_url( 'admin-ajax.php' ),
				'nonce'    => wp_create_nonce( 'entego_n11_urun_ekle' ),
				'edit_urun_nonce'=>wp_create_nonce( 'entego_n11_urun_edit' ),
				'urunSil_n11_nonce'=>wp_create_nonce('entego_n11_urunsil'),
				'kategori_ara_nonce'=>wp_create_nonce('entego_n11_kategori_ara'),
				'destek_bildirim_nonce'=>wp_create_nonce('entego-n11-destek-bildirimi'),
				'urun_kaydetme_nonce'=>wp_create_nonce('entego_n11_urun_kaydetme'),
				'n11_marka_sil'=>wp_create_nonce('entego_n11_marka_sil'),
			) );
		}

		/**
		 * Ürünler sayfası N11 Meta Box Ekleme
		 */
		public function add_meta_box( $post_type ) {
			// Limit meta box to certain post types.
			$post_types = array( 'product');
	
			if ( in_array( $post_type, $post_types ) ) {
				add_meta_box(
					'entego_n11_urun_metabox',
					__( 'N11 Kategori Ürün Nitelikleri', 'entego-n11' ),
					array( $this, 'meta_box_urunler' ),
					$post_type,
					'side',
					'default'
				);
			}
		}

		/**
		 * Kategori eşleştirmesi yapılmamış ürünlerin kategori
		 * eşleme post işlemi
		 *
		 */
		public function kategori_esle() {

			$nonce 			= sanitize_text_field($_POST['_nonce']);
            $id 			= sanitize_text_field($_POST['post_id']);
            $kategori_id 	= sanitize_text_field($_POST['kategori_id']);
            $kategori_adi 	= sanitize_text_field($_POST['kategori_adi']);
	
			if ( ! wp_verify_nonce( $nonce, 'entego_n11_urun_edit' ) || !isset($id) || !isset($kategori_adi) || !isset($kategori_id)) {
				wp_send_json(array('sonuc'=>false,'mesaj'=>esc_html('Eksik veriler oluştu, daha sonra tekrar deneyiniz.','entego-n11')));
			}else {

                $up1 = update_post_meta($id,'n11Kategori_id',$kategori_id);
                $up2 = update_post_meta($id,'n11Kategori_adi',$kategori_adi);
				if(!$up1 || !$up2){
					$sonuc = array(
						'sonuc'=>false,
						'mesaj'=>esc_html('Bilinmeyen bir hata oluştu, lütfen daha sonra tekrar deneyiniz.','entego-n11'),
					);
				}else {
					$sonuc = array(
						'sonuc'=>true,
						'mesaj'=>esc_html('Eşleştirme başarıyla kayıt edildi.','entego-n11'),
					);
				}
				wp_send_json($sonuc);
			}
		}
		
		/**
		 * Ürün Kategorisi Eşleştirme Kaldırma Fonksiyonu
		 * Ürün Düzenelem Sayfası
		 * 
		 */
		public function urunKategoriEslestirmeKaldir(){
			$id 	= sanitize_text_field($_POST['id']);
			$nonce 	= sanitize_text_field($_POST['nonce']);
			if(!isset($id) || !wp_verify_nonce($nonce,'urun-kategori-kaldir')){
				wp_send_json([
					'sonuc'	=> false,
					'mesaj'	=> esc_html('Eksik bilgiler mevcut lütfen sayfayı yenileyip tekrar deneyiniz.','entego-n11'),
				]);
			}
			$ozellikler = get_post_meta($id,'entegoN11Ozellikler',true);
			if(count(explode(',',$ozellikler)>0) && isset($ozellikler)){
				$ozellikler = explode(',',$ozellikler);
				foreach($ozellikler as $ozellik){
					delete_post_meta($id,'entegoN11Ozellik||'.$ozellik);
				}
			}elseif(isset($ozellikler)) {
				delete_post_meta($id,'entegoN11Ozellik||'.$ozellikler);
			}
			delete_post_meta($id,'entegoN11Ozellikler');
			$del1 = delete_post_meta($id,'n11Kategori_id');
			$del2 = delete_post_meta($id,'n11Kategori_adi');
			if(!$del1 || !$del2){
				wp_send_json([
					'sonuc'=>false,
					'mesaj'=>'Kategori eşleştirmesi kaldırırken sorun oluştu, lütfen daha sonra tekrar deneyiniz.',
				]);
			}else {
				wp_send_json([
					'sonuc'=>true,
					'mesaj'=>'Kategori eşleştirmesi kaldırıldı, sayfa yenileniyor.'
				]);
			}
		}
        

		/**
		 * Ürünler Sayfası Meta Kutusu İçeriği
		 *
		 */
		public function meta_box_urunler( $post ) {
			$urunId         = $post->ID;
            $product        = wc_get_product($urunId);
            $n11Id          = get_post_meta($urunId,'n11Kategori_id');
			if(count($n11Id)){
				if(get_post_meta($urunId,'entegoN11UrunGondermeButon',true)){
					delete_post_meta($urunId,'entegoN11UrunGondermeButon');
					$sonuc = $this->N11Class_gonder($urunId);
					if($sonuc['success'] == false){
						?>
						<div class="notice notice-error is-dismissible">
							<p><?=$sonuc['mesaj']?></p>
						</div>
						<?php
					}else {
						?>
						<div class="notice notice-success is-dismissible">
							<p><?=$sonuc['mesaj']?></p>
						</div>
						<?php
					}
				}
				?>
				<div style="margin: 0 -12px -12px;" class="submitbox n11_meta_box" id="submitpost">
					<div id="minor-publishing">
						<div id="misc-publishing-actions">
							<?php
								if(get_post_meta($urunId,'n11urunId',false)){
									$durum = esc_html('Yayımlanmış','entego-n11');
								}else {
									$durum = esc_html('Yayımlanmamış','entego-n11');
								}
							?>
							<div class="misc-pub-section misc-pub-post-status">
								Durum: <span id="post-status-display">
								<?=$durum?></span>
							</div>
						</div>


						<div class="misc-pub-section" id="">
							<p class="hide-if-no-js howto"><b>N11 Kategori: </b><?php echo get_post_meta($urunId,'n11Kategori_adi')[0]; ?></p>
							<?php
							if(!get_post_meta($urunId,'n11urunId',false)){
							?>
							<p class="hide-if-no-js howto"><a class="kategoriKaldır" data-id="<?=$urunId?>" data-nonce="<?=wp_create_nonce("urun-kategori-kaldir")?>" href="#">Kategori Eşleştirmesi Kaldır</a></p>
							<?php
							}
							echo '<p class="hide-if-no-js howto">'.esc_html("Zorunlu olan ürün özelliğinin seçilmesi mecburidir, aksi halde ürün N11'e gönderemezsiniz.",'entego-n11').'</p>';

							$cevap = Entego_N11_Admin::ozelliklerDegerlerGetir($n11Id[0]);
							if(!$cevap['sonuc']){
								if($cevap['mesaj']== 'entego_key_yok'){
									echo '<p style="color:red">'.esc_html('Ayarlar sayfasında eklenti api anahtarı ve api şifresini girerek kaydedip doğrulamanız gerekiyor.','entego-n11').'</p>';
								}elseif($cevap['mesaj']=='entego_baglanti_yok'){
									echo '<p style="color:red">'.esc_html('Entego API ile bağlantı sağlanamadı, daha sonra tekrar deneyiniz.','entego-n11').'</p>';
								}else {
									echo '<p style="color:red">'.$cevap['mesaj'].'</p>';
								}
							}else {
								$ozellikler = $cevap['degerler'];
								foreach($ozellikler as $attri){
									if($attri->zorunluluk){$zor='<strong style="color:red;"> -'.esc_html('Zorunlu','entego-n11').'</strong>';}else {$zor=null;}
									?>
										<div style="margin:10px 0;" class="form-field form-required term-name-wrap">
											<label for="entego_n11_urun_attributes"><?=$attri->nitelik_adi.' '.$zor?></label>
											<select style="width:100%" name="entego_n11_urun_attributes[]" class="aramaSelect2" id="entego_n11_urun_attributes">
												<option value="">Seçim Yapınız</option>
												<?php
												foreach($attri->degerler as $deger){
													$selected = null;
												if(get_post_meta($urunId,'entegoN11Ozellik||'.$attri->nitelik_adi ,true) == $deger->deger.'||'.$deger->id){
													$selected = ' selected';
												}
												?>
												<option value="<?=$attri->nitelik_adi?>&&<?=$deger->deger?>&&<?=$deger->id?>"<?=$selected?>><?=$deger->deger?></option>
												<?php
												}
												?>
											</select>
										</div>
									<?php
								}
							}
							?>
						</div>
						<?php
						if(get_post_meta($urunId,'n11urunId',false)){$autoRefresh = ' style="display:block;"';}else{$autoRefresh = ' style="display:none;"';}
						?>
						<div class="misc-pub-section autoRefreshN11"<?=$autoRefresh?>>
							<p class="hide-if-no-js howto"><?=esc_html('WooCommerce üzerinde ürünü güncellediğinizde otomatik olarak n11\'de güncellenmesini istiyorsanız seçin','entego-n11')?></p>
							<?php
								if(get_post_meta($urunId,'urunN11OtomatikGuncelle',false)){
									if(get_post_meta($urunId,'urunN11OtomatikGuncelle',true) == 'true'){
										$value1 = '';
										$value2 = 'selected';
										$text = esc_html('Açık','entego-n11');
									}else {
										$value1 = 'selected';
										$value2 = '';
										$text = esc_html('Kapalı','entego-n11');
									}
								}else {
									if(get_option('entego_n11_autosave') == 'true'){
										$value1 = '';
										$value2 = 'selected';
										$text = esc_html('Açık','entego-n11');
									}else {
										$value1 = 'selected';
										$value2 = '';
										$text = esc_html('Kapalı','entego-n11');
									}
								}
							?>
							<?=esc_html('Otomatik Güncelleme','entego-n11')?>: <span id="urun_yenileme_sonuc"><strong><?=$text?></strong></span>
							<a href="#duzenle_urun_auto_refresh" class="duzenle_urun_auto_refresh_durum hide-if-no-js" role="button" style="display: inline;"><span aria-hidden="true"><?=esc_html('Düzenle','entego-n11')?></span> <span class="screen-reader-text"><?=esc_html('Düzenle','entego-n11')?></span></a>
								
							<div id="duzenle_urun_auto_refresh_kutu" class="hide-if-js" style="display: none;">
								<label for="duzenle_urun_auto_refresh" class="screen-reader-text"><?=esc_html('Otomatik Güncelleme Değiştir','entego-n11')?></label>
								<select name="duzenle_urun_auto_refresh" id="duzenle_urun_auto_refresh">
										<option value="false" <?=$value1?>><?=esc_html('Kapalı','entego-n11')?></option>
										<option value="true" <?=$value2?>><?=esc_html('Açık','entego-n11')?></option>
								</select>
								<a href="#" class="duzenle_urun_auto_refresh_kaydet hide-if-no-js button"><?=esc_html('Tamam','entego-n11')?></a>
								<a href="#" class="duzenle_urun_auto_refresh_iptal hide-if-no-js button-cancel"><?=esc_html('Vazgeç','entego-n11')?></a>
							</div>
						</div>
					</div>
					<div id="n11-urun-puplishing-actions">
						<?php
						if(get_post_meta($urunId,'urunN11OtomatikGuncelle',true) == 'true'){
							$disabled = ' disabled="disabled" ';
						}else{$disabled=null;}
						if(get_post_meta($urunId,'n11urunId',false)){
							$guncelle = esc_html("Ürünü N11'de Güncelle",'entego-n11');
							$silBtn = ' style="display:block;"';
						}else{
							$guncelle = esc_html("Ürünü N11'e Kaydet",'entego-n11');
							$silBtn = ' style="display:none;"';
						}
						?>
						<div id="delete-action" class="silBtn"<?=$silBtn?>>
							<a class="submitdelete n11UrunSil deletion" data-id="<?=$post->ID?>" href=""><?=esc_html("Ürünü N11'den SİL",'entego-n11')?></a>
						</div>
						<div id="publishing-action">
							<span class="spinner"></span>
							<input type="hidden" name="urun_id" value="<?=$urunId?>">
							<input name="n11Kaydet" data-id="<?=$post->ID?>" type="button" class="button button-primary button-large" id="" value="<?=$guncelle?>"<?=$disabled?>>
						</div>
						<div class="clear"></div>
					</div>
				</div>
				<?php
			}else {
				$kategoAdlari = [];
				foreach($product->get_category_ids() as $cId){
					$terms = get_term($cId);
					$kategoAdlari[] = $terms->name;
				}
				$kategoriAdlari = implode(' ',$kategoAdlari);
				$kategoriSorgu = $product->get_name().' '.$kategoriAdlari;
				
				$cevap = Entego_N11_Admin::kategoriSorgulama($kategoriSorgu);
				if(!$cevap['sonuc']){
					if($cevap['mesaj']=='entego_key_yok'){
						echo '<div class="kategoriBox">
								<p>'.esc_html('Ayarlar sayfasından api anahtarı ve api şifrenizi girerek doğrulama yapmalısınız.','entego-n11').'</p>
							</div>';
					}elseif($cevap['mesaj']=='entego_baglanti_yok'){
						echo '<div class="kategoriBox">
								<p>'.esc_html('Entego API ile bağlantı sağlanamadı, lütfen daha sonra tekrar deneyiniz.','entego-n11').'</p>
							</div>';
					}else {
						echo '<div class="kategoriBox">
								<p>'.$cevap['mesaj'].'</p>
							</div>';
					}
				}else {
				?>
					<div class="kategoriBox">
						<input type="hidden" name="post_id" value="<?=$urunId?>">
						<p class="hide-if-no-js howto"><?=esc_html('WooCommerce Kategorisi N11 Kategorisi ile eşleştirilmemiş. Ürün N11 Ayarlarını yapmak için öncelikle kategori eşleştirmelisiniz.','entego-n11')?></p>
						<p class="hide-if-no-js howto"><?=esc_html('Aşşağıdaki kategori önerilerinden uygun olanın üzerine tıklayarak seçebilirsiniz, eğer hiç biri sizin ürününüzün kategorisiyle uyum sağlamıyor ise kategori arayabilir ve o listeden seçebilirsiniz.','entego-n11')?></p>
						<p class="hide-if-no-js howto"><?=esc_html('Kategori Önerileri','entego-n11')?> :</p>
						<?php
							foreach($cevap['sonuclar'] as $key => $sonuc){
						?>
							<a href="#" class="kategoriOneriSec" data-postid="<?=$post->ID?>"  data-value="<?=$sonuc['id']?>"><?=$sonuc['text']?></a>
						<?php
							}
						?>
						<br>
						<label class="lKategoriArama" for="kategoriArama">Kategori Arama</label>
						<select placeholder="Aramak için tıklayınız." name="kategoriArama" id="kategoriArama" class="wc-enhanced-select-init kategoriArama">
							<option value="">Kategori Arama..</option>
						</select>

						<div style="text-align: right;" class="form-field form-required term-name-wrap">
							<br>
							<button class="kategoriEsle kategoriEkleBtn button"><?=esc_html('Eşleştir','entego-n11')?></button>
						</div>
					</div>
				<?php
				}
			}
		}


		/**
		 * N11 Kategorisi Nitelikleri getirme
		 *
		 */
		public function get_n11_attributes($kategori_id){
			$key        = get_option('entego_n11_api_key');
			$key2       = get_option('entego_n11_api_secret_key');
			$entego_key = get_option('entego_n11_key');
			if($entego_key == ''){
				return array(
					'sonuc'=>false,
					'mesaj'=> esc_html('Entego İle bağlantı sağlayıp kayıt yaptırmalısınız. Ayarlar sayfasından yapabilirsiniz.','entego-n11'),
				);
			}

			$response = Entego_N11_Baglanti::HTTPPost("niteliklerGonder", array(
				'api_key' => $key,
				'api_secret_key' => $key2,
				'alan_adi'	=> get_site_url(),
				'entego_key' => $entego_key,
				'kategori_id' => $kategori_id,
			));
			if($response == ''){
				return array(
					'sonuc'=>false,
					'mesaj'=> esc_html('Entego API ile bağlantı sağlanamadı, daha sonra tekrar deneyiniz.','entego-n11'),
				);
			}
			$cevap = json_decode($response);
			if(!$cevap->sonuc){
				return array(
					'sonuc'=>false,
					'mesaj'=> $cevap,
				);
			}
			$n11Sonuc = $cevap->degerler;
			return $n11Sonuc;
		}

		public function array_value_recursive($key, array $arr){
			$val = array();
			array_walk_recursive($arr, function($v, $k) use($key, &$val){
				if($k == $key) array_push($val, $v);
			});
			return count($val) > 1 ? $val : array_pop($val);
		}

		/**
		 * Varyasyonlu Ürünlerin varyasyonlarına GTIN, OEM ve N11 Fiyatı inputları
		 */
		public function varyasyon_meta_box($loop, $variation_data, $variation){
			$GTINvalue = end($variation_data['variable_gtin']);
			$OEMvalue = end($variation_data['variable_oem']);
			$FIYATvalue = end($variation_data['variable_n11_fiyat']);
			woocommerce_wp_text_input(
				array(
					'id'            => "variable_gtin{$loop}",
					'name'          => "variable_gtin[{$loop}]",
					'value'         => $GTINvalue,
					'label'         => '<abbr title="' . esc_attr__( 'Ürünün global ticari öğe numarası', 'entego-n11' ) . '">' . esc_html__( 'GTIN', 'entego-n11' ) . '</abbr>',
					'desc_tip'      => true,
					'description' => __( 'N11 tarafından bazı OEM ürünlerde zorunlu olarak istenmektedir. Eğer Bilmiyorsanız N11 yönetici panelinden sorgulatarak öğrene bilirsiniz.', 'entego-n11' ),
					'wrapper_class' => 'form-row form-row-first',
				)
			);
			woocommerce_wp_text_input(
				array(
					'id'            => "variable_oem{$loop}",
					'name'          => "variable_oem[{$loop}]",
					'value'         => $OEMvalue,
					'label'         => '<abbr title="' . esc_attr__( 'Parça/Ürün bağlantı numarası', 'entego-n11' ) . '">' . esc_html__( 'OEM', 'entego-n11' ) . '</abbr>',
					'desc_tip'      => true,
					'description'   => __( 'N11\'de ürün listelemek için kullanılan bir özellik isteğe bağlıdır.', 'entego-n11' ),
					'wrapper_class' => 'form-row form-row-last'
				)
			);
			woocommerce_wp_text_input(
				array(
					'id'            => "variable_n11_fiyat{$loop}",
					'name'          => "variable_n11_fiyat[{$loop}]",
					'value'         => $FIYATvalue,
					'label'     	=> '<abbr title="' . esc_attr__('N11.com\'da satmak istediğiniz tutar', 'entego-n11' ) . '">' . esc_html__( 'N11 Satış Ücreti', 'entego-n11' ) . '</abbr>',
					'desc_tip'      => true,
					'description' 	=> __( 'Eğer N11.com\'a farklı fiyatta göndermek istiyorsanız, fiyat sekmesine bunu girmelisiniz.', 'entego-n11' ),
					'wrapper_class' => 'form-row',
					'class'		    => 'short wc_input_price'
				)
			);
		}

		/**
		 * Basit Ürünler Sayfası GTIN ve OEM inputları Ekleme
		 * 
		 */
		public function basit_urun_meta_box() {
			$post_id = sanitize_text_field($_GET['post']);
			woocommerce_wp_text_input(
				array(
					'id'          => '_n11_fiyat',
					'name'        => '_n11_fiyat',
					'value'       => get_post_meta($post_id,'_n11_fiyat',true),
					'label'       => '<abbr title="' . esc_attr__('N11.com\'da satmak istediğiniz tutar', 'entego-n11' ) . '">' . esc_html__( 'N11 Satış Ücreti', 'entego-n11' ) . '</abbr>',
					'desc_tip'    => true,
					'description' => __( 'Eğer N11.com\'a farklı fiyatta göndermek istiyorsanız, fiyat sekmesine bunu girmelisiniz.', 'entego-n11' ),
					'class'		  => 'short wc_input_price'
				)
			);
			woocommerce_wp_text_input(
				array(
					'id'          => '_gtin',
					'name'        => '_gtin',
					'value'       => get_post_meta($post_id,'_gtin',true),
					'label'       => '<abbr title="' . esc_attr__('Ürünün global ticari öğe numarası', 'entego-n11' ) . '">' . esc_html__( 'GTIN', 'entego-n11' ) . '</abbr>',
					'desc_tip'    => true,
					'description' => __( 'N11 tarafından bazı OEM ürünlerde zorunlu olarak istenmektedir. Eğer Bilmiyorsanız N11 yönetici panelinden sorgulatarak öğrene bilirsiniz.', 'entego-n11' ),
				)
			);
			woocommerce_wp_text_input(
				array(
					'id'          => '_oem',
					'name'        => '_oem',
					'value'       => get_post_meta($post_id,'_oem',true),
					'label'       => '<abbr title="' . esc_attr__('Parça/Ürün bağlantı numarası', 'entego-n11' ) . '">' . esc_html__( 'OEM', 'entego-n11' ) . '</abbr>',
					'desc_tip'    => true,
					'description' => __( 'N11\'de ürün listelemek için kullanılan bir özellik isteğe bağlıdır.', 'entego-n11' ),
				)
			);
		}

		/**
		 * Basit ürün Kaydında GTIN ve OEM Veritabanına kayıt
		 * 
		 */
		public function basit_urun_kaydet($post_id, $post, $update) {
			if($post->post_type == 'product'){
				$products = wc_get_product( $id );
				if($products->get_type = 'simple'){
					update_post_meta($post_id, '_n11_fiyat', sanitize_text_field($_POST['_n11_fiyat']));
					update_post_meta($post_id, '_oem', sanitize_text_field($_POST['_oem']));
					update_post_meta($post_id, '_gtin', sanitize_text_field($_POST['_gtin']));
				}


				$idler = [];
				$ozellik = $_POST['entego_n11_urun_attributes'];
				foreach($ozellik as $ozz){
					if($ozz){
						$oz = explode('&&',$ozz);
						update_post_meta($post_id, 'entegoN11Ozellik||'.$oz[0] , $oz[1].'||'.$oz[2]);
						$idler[] = $oz[0];
					}
				}
				update_post_meta($post_id,'entegoN11Ozellikler',implode(",",$idler));


				update_post_meta($post_id, 'urunN11OtomatikGuncelle', sanitize_text_field($_POST['duzenle_urun_auto_refresh']));
				
				return true;
			}
		}

		/**
		 * Varyasyonlu ürün Kaydında GTIN ve OEM Veritabanına kayıt
		 * 
		 */
		public function varyasyonlu_urun_kaydet($variation_id, $i) {
				update_post_meta($variation_id, 'variable_gtin', sanitize_text_field($_POST['variable_gtin'][$i]));
				update_post_meta($variation_id, 'variable_oem', sanitize_text_field($_POST['variable_oem'][$i]));
				update_post_meta($variation_id, 'variable_n11_fiyat', sanitize_text_field($_POST['variable_n11_fiyat'][$i]));
		}
		

		/**
		 * Tek Ürün N11'e gönderme Fonksiyonu
		 * 
		 */
		public function urun_gonder($id){
				$sonuc = $this->N11Class_gonder($id);
				wp_send_json($sonuc);
		}

		/**
		 * Ürünleri görüntüleme sayfası filtler sekmesi N11 Ekleme
		 */
		public function n11_filitreleri($post_type){
			$value1 = '';

			if( isset( $_GET['n11_filtresi'] ) ) {
				switch( sanitize_text_field($_GET['n11_filtresi']) ) {

					case 'true':
					$value1 = ' selected';
					break;


				}
			}

			if( $post_type == 'product' ) {
				echo '<select name="n11_filtresi">';
			
				echo '<option value>'.esc_html('Tümünü Göster','entego-n11').'</option>';
				echo '<option value="true"'.$value1.'>'.esc_html('N11\'de bulunanlar','entego-n11').'</option>';
			
				echo '</select>';
			
			}
		}
		
		/**
		 * Ürünleri görüntüleme sayfası filtler sekmesi N11 Ekleme
		 */
		public function n11_filitreleri_goruntule($query ){
			global $pagenow;

			if ( $query->is_admin && $pagenow == 'edit.php' && isset( $_GET['n11_filtresi'] ) && $_GET['n11_filtresi'] != '' && $_GET['post_type'] == 'product' ) {
				if(sanitize_text_field($_GET['n11_filtresi']) == true){
					$meta_key_query = array(
						array(
						'key'     => 'n11urunId'
						)
					);
					$query->set( 'meta_query', $meta_key_query );
				}

			}
		}

		/**
		 * Tüm Ürünler Sayfası Table Column Ekleme Fonksiyonu
		 * 
		 */
		public function tablo_ekle_column_1($columns){
			$columns['n11_column'] = esc_html('N11 Durumu','entego-n11');
			$columns['product_cat'] = esc_html('N11 ve WooCommerce Kategorisi','entego-n11');
   			return $columns;
		}

		/**
		 * Tüm Ürünler Sayfası Table Column Ekleme Fonksiyonu
		 * 
		 */
		public function tablo_ekle_column_2($column,$product_id){
			if ( $column == 'n11_column' ) {
				if(get_post_meta($product_id,'n11urunId',false)){
					echo '<img style="text-align:center;" title="'.esc_html('Ürün N11\'e gönderilmiş.','entego-n11').'" width="35px" height="35px" src="'.plugin_dir_url(__FILE__).'../img/ok.png'.'" />';
				}else {
					echo '<img style="text-align:center;" title="'.esc_html('Ürün N11\'e gönderilmemiş.','entego-n11').'" width="35px" height="35px" src="'.plugin_dir_url(__FILE__).'../img/cancel.png'.'" />';
				}
			}

			// Kategoriler Sekemesine N11 Kategorilerini Ekleme
			if ( $column == 'product_cat' ) {
				$kategori = get_post_meta($product_id,'n11Kategori_adi');
				if($kategori[0]){
					echo $kategori[0].', ';
				}
			}
		}
		/**
		 * N11.com'dan Ürün silmek için fonksiyon
		 * AJAX İşlemi Ürün Düzenle Sayfası
		 */
		public function n11_urun_sil(){
            $id = sanitize_text_field($_POST['id']);
			if(wp_verify_nonce( sanitize_text_field($_POST['nonce']), 'entego_n11_urunsil' ) && isset($id)){
                delete_post_meta($id,'n11ProductSellerCode');
				$sonuc = $this->urun_sil($id);
				if($sonuc->result->status == 'success'){
					wp_send_json(array(
						'sonuc'=>true,
						'mesaj'=>esc_html('Başarıyla Silindi','entego-n11'),
						'donen'=>$sonuc
					));
				}elseif($sonuc->result->errorCode == "SELLER_API.notFound"){
					wp_send_json(array(
						'sonuc'=>true,
						'mesaj'=>esc_html('Silmek istediğiniz ürün daha önce silinmiş veya hiç kayıt edilmemiş olabilir.','entego-n11'),
						'donen'=>$sonuc
					));
				}elseif($sonuc->result->errorMessage == 'Yetersiz Kredi') {
					wp_send_json(array(
						'sonuc'=>false,
						'mesaj'=>esc_html('İşlem yapmak için kullandığınız krediniz tükenmiştir. Satın almak için internet sitemizi ziyaret ediniz.','entego-n11'),
					));
				}elseif($sonuc->sonuc == false) {
					wp_send_json(array(
						'sonuc'=>false,
						'mesaj'=>$sonuc->mesaj,
					));
				}else {
					wp_send_json(array(
						'sonuc'=>false,
						'mesaj'=>esc_html('Bilinmeyen bir hata oluştu, daha sonra tekrar deneyiniz.','entego-n11'),
						'donen'=>$sonuc
					));
				}
			}else {
				wp_send_json(array(
					'sonuc'=>false,
					'mesaj'=>esc_html('Ajax doğrulamasında bir hata oluştu, sayfayı yenileyip tekrar deneyiniz.','entego-n11')
				));
			}
		}

		/**
		 * ÜRÜN SİLME FONKSİYONU
		 * 
		 * $id = WooCommerce Product ID
		 */
		public function urun_sil($id){
			$n11Id = get_post_meta($id,'n11urunId',true);
			$key        = get_option('entego_n11_api_key');
			$key2       = get_option('entego_n11_api_secret_key');
			$entego_key = get_option('entego_n11_key');
			if($entego_key == ''){
				return array(
					'sonuc'=>false,
					'mesaj'=> esc_html('Entego İle bağlantı sağlayıp kayıt yaptırmalısınız. Ayarlar sayfasından yapabilirsiniz.','entego-n11'),
				);
			}

			$response = Entego_N11_Baglanti::HTTPPost("urunSil", array(
				'api_key' => $key,
				'api_secret_key' => $key2,
				'alan_adi'	=> get_site_url(),
				'entego_key' => $entego_key,
				'seller_code' => $n11Id,
			));
			if($response == ''){
				return array(
					'sonuc'=>false,
					'mesaj'=> esc_html('Entego API ile bağlantı sağlanamadı, daha sonra tekrar deneyiniz.','entego-n11'),
				);
			}
			$sonuc = json_decode($response);
			if($sonuc->result->status == 'success' || $sonuc->result->errorCode == "SELLER_API.notFound"){
				delete_post_meta($id,'n11urunId');
				delete_post_meta($id,'urunN11OtomatikGuncelle');
				delete_post_meta($id,'n11ProductSellerCode');
				$this->hataVarmiKontrol($id);
			}
			return $sonuc;
		}

		/**
		 * Footer Yazısı Düzenleme
		 * Ürün Düzenleme Sayfası
		 */
		public function footer_duzenle($footer_text){
				// Wordpress Bulunduğumuz sayfa
				$current_screen     = get_current_screen();
				// Entego Footer Yazsının gözükmesi gereken sayfalar
				$entego_n11_sayfalar       = array(
					'toplevel_page_entego_n11_ayarlar',
					'entego_page_entego_n11_sonuclar',
					'entego_page_entego_n11_kategoriler',
                    'entego_page_entego_n11_siparisler',
                    'entego_page_entego_n11_help',
					'entego_page_entego_n11_destek',
				);
				if ( isset( $current_screen->id ) && apply_filters( 'entego_entegrasyon_text', in_array( $current_screen->id, $entego_n11_sayfalar, true ) ) ) {
					$footer_text = __( '<strong>Entego WooCommerce Entegrasyon</strong> eklentimizi beğendiyseniz lütfen bize <a href="https://tr.wordpress.org/plugins/entego-n11" target="_blank">yorum</a> yapmayı unutmayınız. <br>Şimdiden yapacağınız her türlü yorum için teşekkür ederiz.', 'entego-n11' );
				}
				return $footer_text;
		}

		public function footer_duzenle_update($footer_text){
			// Wordpress Bulunduğumuz sayfa
			$current_screen     = get_current_screen();
			// Entego Footer Yazsının gözükmesi gereken sayfalar
			$entego_n11_sayfalar       = array(
				'toplevel_page_entego_n11_ayarlar',
				'entego_page_entego_n11_sonuclar',
				'entego_page_entego_n11_kategoriler',
				'entego_page_entego_n11_siparisler',
				'entego_page_entego_n11_help',
				'entego_page_entego_n11_destek',
			);
			if ( isset( $current_screen->id ) && apply_filters( 'entego_entegrasyon_text', in_array( $current_screen->id, $entego_n11_sayfalar, true ) ) ) {
				$footer_text = 'Sürüm: '.ENTEGO_N11_VERSION;
			}
			return $footer_text;
		}

		/**
		 * Otomatik Güncelleme Fonksiyonu
		 * 
		 */
		public function otomatik_guncelleme($post_id,$post,$update){
			$autoUpdate = get_post_meta($post_id,'urunN11OtomatikGuncelle',true);
			if($autoUpdate == 'true'){

				$gonder = $this->N11Class_gonder($post_id);

					 if($gonder['hataKodu'] == 'kategori_nitelik_eksik'){
						$this->hataKaydet($post_id,'zorunlu_nitelik',esc_html('Ürün otomatik olarak güncellenirken zorunlu olan özelliklerden eksik bulundu.','entego-n11'),'otomatik_guncelleme',1,1);
				}elseif($gonder['hataKodu'] == 'sablon_yok'){
					$this->hataKaydet($post_id,'sablon_yok',esc_html('Varsayılan şablon seçmediniz. Ayarlar sayfasından varsayılan şablon seçmeslisiniz.','entego-n11'),'otomatik_guncelleme',1,1);
				}elseif($gonder['hataKodu'] == 'kategori_yok'){
					$this->hataKaydet($post_id,'kategori_bulunamadi',esc_html('Ürün Otomatik olarak Güncellenirken ürün n11 kategorisi eşleştirmediği için göndeirlmedi.','entego-n11'),'otomatik_guncelleme',1,1);
				}elseif($gonder['hataKodu'] == 'fazla_resim'){
					$this->hataKaydet($post_id,'urun_gorsel_sayisi_fazla',esc_html('Ürün Görsel Sayısı 12 den fazla olamaz.','entego-n11'),'otomatik_guncelleme',1,1);
				}elseif($gonder['hataKodu'] == 'basarili'){
					$this->hataKaydet($post_id,'urun_guncelleme_basarili',esc_html('Ürün Başarıyla N11\'de Güncellendi.','entego-n11'),'otomatik_guncelleme',2,1);
				}elseif($gonder['hataKodu'] == 'n11_hatasi'){
					$this->hataKaydet($post_id,'urun_guncelleme_basarisiz_n11_hatasi',esc_html('Ürün N11\'e gönderilken bir hata oluştu. - N11 Hata Mesajı:','entego-n11').$gonder['urunSonuc']->result->errorMessage,'otomatik_guncelleme',1,1);
				}else {
					$this->hataKaydet($post_id,'bilinmeyen_hata',esc_html('Ürün N11\'e gönderilken bir hata oluştu. - N11 Hata Mesajı:','entego-n11').$gonder['urunSonuc']->result->errorMessage,'otomatik_guncelleme',1,1);
				}
			}
		}

		/**
		 * Varyasyon Güncellemesi Yakalama Fonksiyonu
		 * 
		 */
		public function otomatik_guncelleme_varyasyon($post_id){
			$id = wp_get_post_parent_id($post_id);
			$this->otomatik_guncelleme($id,1,1);
		}

		/**
		 * Ürün Resimleri @return 
		 * Etme
		 */
		public function resimler($products){

			/** Ürün Resimlerini Dizi Haline getirme BAŞLANGIÇ */
				$resimler = array(
					0 => [
						'resim_url'=> wp_get_attachment_image_src( $products->get_image_id(), 'full' )[0],
						//'resim_url'=>'https://i.picsum.photos/id/871/500/500.jpg',
						'resim_sira'=>1
					]
				);
				$i = 2;
				foreach($products->get_gallery_image_ids() as $resim_id){
					$images = array(
						'resim_url'=>wp_get_attachment_image_src( $resim_id,'full' )[0],
						//'resim_url'=>'https://i.picsum.photos/id/872/500/500.jpg',
						'resim_sira'=>$i
					);
					array_push($resimler,$images);
					$i++;
				}
				return $resimler;
			/** Ürün Resimlerini Dizi Haline getirme BİTİŞ */
		}

		/**
		 * Hata Kaydetme
		 * 
		 */
		public function hataKaydet($id,$hata,$hataMesaj,$islem,$durum,$goruldu){
			global $wpdb;
			$tablo_adi = $wpdb->prefix . "entego_n11_hatalar";
			$data = array(
				'post_id' => $id,
				'hata'=>$hata,
				'hata_mesaj'=>$hataMesaj,
				'islem'=>$islem,
				'durum'=>$durum,
				'goruldu'=>$goruldu
			);
			$wpdb->delete($tablo_adi,array('post_id'=>$id));
			$insert = $wpdb->insert($tablo_adi,$data);
		}

		/**
		 * N11 Ürün Gönder Fonksiyonu
		 * 
		 */
		public function N11Class_gonder($id){

			$products = wc_get_product( $id );
			$n11KategoriId = get_post_meta($id,'n11Kategori_id');
			$n11Ozellikleri = $this->entego_n11_ozellikler_gonder($id);
			
			if(@$sellerId = get_post_meta($id,'n11ProductSellerCode',true)){
				$urunKodu = $sellerId;
				$urunGuncelle = true;
			}else {
				$urunKodu = 'N11-PR-'.$id;
				$urunGuncelle = false;
			}
			$key        = get_option('entego_n11_api_key');
			$key2       = get_option('entego_n11_api_secret_key');
			$entego_key = get_option('entego_n11_key');
			
			if($entego_key == ''){
				return array(
					'success'=>false,
					'hataKodu'=>'entego_key_yok',
					'mesaj'=> esc_html('Entego İle bağlantı sağlayıp kayıt yaptırmalısınız. Ayarlar sayfasından yapabilirsiniz.','entego-n11'),
				);
			}elseif(!$n11KategoriId[0]){
				$sonuc = array(
					'success'=>false,
					'hataKodu'=>'kategori_yok',
					'mesaj'=>esc_html('Kategori Eşleştirmesi bulunamadı.','entego-n11'));
				return $sonuc;
			}elseif(get_option('n11_varsayilan_sablon',true) == ''){
				$sonuc = array(
					'success'=>false,
					'hataKodu'=>'sablon_yok',
					'mesaj'=>esc_html('Varsayılan Şablon Seçmelisiniz.','entego-n11'));
				return $sonuc;
			}elseif(get_option('entego_n11_kargo_suresi',true) == ''){
				$sonuc = array(
					'success'=>false,
					'hataKodu'=>'kargo_teslim_yok',
					'mesaj'=>esc_html('Kargo Teslim Süresi Belirtilmemiş.','entego-n11'));
				return $sonuc;
			}elseif($this->stokKontrol($id)){
				$sonuc = array(
					'success'=>false,
					'hataKodu'=>'stok_yok',
					'mesaj'=>esc_html('Ürün Stoğu tükenmiş','entego-n11'));
				return $sonuc;
			}else {
				//Ürün gönderme başlangıç
				$attr = [];
				$n11NitelikId = $this->get_n11_attributes($n11KategoriId[0]);
				if(isset($n11NitelikId->sonuc)){
					$sonuc = array(
						'success'=>false,
						'hataKodu'=>'nitelik_request_hatasi',
						'mesaj'=>esc_html('Nitelikleri getirilirken bir hata oluştu.','entego-n11'),
					);
					return $sonuc;
				}
				$n11NitelikAdlari = array_column($n11NitelikId, 'nitelik_adi');
				// Ürün Özellikleri Zorunluluk Kontrolü
					$socs = [];
					foreach($n11NitelikId as $nitelik){
						if($nitelik->zorunluluk == true && $nitelik->coklu == false && in_array($nitelik->nitelik_adi, @$n11Ozellikleri['ozellikler']) == false ){
							return [
								'success'=>false,
								'hataKodu'=>'eksik_ozellik',
								'mesaj'=>sprintf(
									__('Ürün zorunlu özelliklerinden "%s" eksik, lütfen tekrar kontrol ediniz.','entego-n11'),
									$nitelik->nitelik_adi),
								'n11Ozellikler'=>$n11Ozellikler,
								'search'=>array_search($nitelik->nitelik_adi,@$n11Ozellikleri['ozellikler']),
							];
						}
					}
					
				// Ürün Nitelikleri
				if($n11Ozellikleri!=''){
					foreach($n11Ozellikleri['degerler'] as $nitelik){
							$attr[] = [
								'adi'=>$nitelik['adi'],
								'deger'=>$nitelik['deger'],
							];
					}
				}

				// N11 Fiyatı Alma
					if(get_post_meta($id,'_n11_fiyat',true) != ''){
						$urunFiyati = get_post_meta($id,'_n11_fiyat',true);
						if($urunFiyati == '0.00' || $urunFiyati == '00.00' || $urunFiyati == '00'){
							$urunFiyati = $products->get_price();
							if($urunFiyati == '0.00' || $urunFiyati == '00.00' || $urunFiyati == '00'){
								$urunFiyati = $products->get_regular_price();
							}
						}
					}else {
						$urunFiyati = $products->get_price();
						if($urunFiyati == '0.00' || $urunFiyati == '00.00' || $urunFiyati == '00'){
							$urunFiyati = $products->get_regular_price();
						}
					}
				// #N11 Fİyatı Alma

				if($products->get_type() == 'variable'){
					$fiyatlar =[];
					$available_variations = $products->get_available_variations();
					$variation_variations = $products->get_attributes();
					$varyasyonAdlari = array_keys($variation_variations);
					// WooCommerce Varyasyonları yazma
						$wooAttribute = [];
						$children = [];
						foreach ($available_variations as $taxonomy => $term_names ) {

								$attribute = [];
								foreach($varyasyonAdlari as $varyasyon){
									$name = wc_attribute_label($varyasyon,$products);
									if(@$value = $term_names['attributes']['attribute_'.$varyasyon]){
										array_push($attribute,array(
											'adi'=>$name,
											'deger'=>$value
										));
									}
									
								}
								if(count($attribute) > 0){
									$gtin = get_post_meta($term_names['variation_id'], 'variable_gtin', true);
									$oem = get_post_meta($term_names['variation_id'], 'variable_oem', true);
									$n11VariFiyat = get_post_meta($term_names['variation_id'],'variable_n11_fiyat',true);
									if($n11VariFiyat != '' && $n11VariFiyat != '0.00' && $n11VariFiyat != '00.00' && $n11VariFiyat != '00,00' && $n11VariFiyat != '0,00' ){
										$varyasyonFiyat = $n11VariFiyat;
									}else {
										$varyasyonFiyat = $term_names['display_price'];
									}
									array_push($fiyatlar,$varyasyonFiyat);
									$children[] = array(
										'stok' => $term_names['max_qty'], //Stok Miktarı
										'stok_kodu'=> $term_names['sku'], //Varyasyon Stok Kodu
										'ozellikler'=> $attribute,
										'varyasyon_fiyati'=>$varyasyonFiyat, //Ürün Satış Fiyatı
										'gtin'=>$gtin, //Varyasyon GTIN Değeri (Barkod Kodu)
										'oem'=>$oem, //Varyasyon OEM Değeri
									);
								}
						}

					$urunFiyati = min($fiyatlar);
				}elseif($products->get_type() == 'simple') {
					// Stock İtem
						$children = [array(
								'stok' => $products->get_stock_quantity(), //Stok Miktarı
								'stok_kodu'=> $products->get_sku(), //Varyasyon Stok Kodu
								'ozellikler'=>array(),
								'varyasyon_fiyati'=>$urunFiyati, //Ürün Satış Fiyatı
								'gtin'=>get_post_meta($id, '_gtin', true),
								'oem'=>get_post_meta($id, '_oem', true)
						)];
				}
				
				// Resimler getirme ve resim Sayısı Kontrolü
					$resimler = $this->resimler($products);
					if(count($resimler) > 12){
						$sonuc = array(
							'success'=>false,
							'hataKodu'=>'fazla_resim',
							'mesaj'=>esc_html('Bir ürün için en fazla 12 adet resim gönderebilirsiniz.','entego-n11'));
						return $sonuc;
					}
					// #Resimler getirme ve resim Sayısı Kontrolü

				if(!$urunFiyati){
					$sonuc = array(
						'success'=>false,
						'hataKodu'=>'fiyat_yok',
						'mesaj'=>esc_html('Ürün Fiyatı bulunamadı','entego-n11'),
						'fiyatlar'=>$fiyatlar,
						'urunBilgileri'=>$urunBilgileri
					);
					return $sonuc;
                }
                $max_length = 64;
                $urunBaslik = $products->get_name();
                if (strlen($urunBaslik) > $max_length)
                {
                    $offset = ($max_length - 3) - strlen($urunBaslik);
                    $urunBaslik = substr($urunBaslik, 0, strrpos($urunBaslik, ' ', $offset));
                }

				$satinAlmaNotu = $products->get_purchase_note();
				if($satinAlmaNotu == ''){
					$satinAlmaNotu = $urunBaslik;
				}
                if (strlen($satinAlmaNotu) > $max_length)
                {
                    $offset = ($max_length - 3) - strlen($satinAlmaNotu);
                    $satinAlmaNotu = substr($satinAlmaNotu, 0, strrpos($satinAlmaNotu, ' ', $offset));
                }

				// Ürün Gönderme
				$bilgiler = array(
					'api_key' => $key,
					'api_secret_key' => $key2,
					'alan_adi'	=> get_site_url(),
					'entego_key' => $entego_key,
					'urun_guncelle' => $urunGuncelle,
					'seller_code'=>$urunKodu,
					'urun_baslik' => $urunBaslik,
					'alt_baslik' => $satinAlmaNotu,
					'aciklama' => $products->get_description(),
					'ozellikler' =>$attr,
					'kategori_id' =>$n11KategoriId[0],
					'urun_fiyati' => $urunFiyati,
					'para_birimi' => 'TL',
					'resimler' => $resimler,
					'kargo_teslim' => get_option('entego_n11_kargo_suresi',true),
					'teslimat_sablonu' => get_option('n11_varsayilan_sablon',true),
					'varyasyonlar' => $children
				);

				$response = Entego_N11_Baglanti::HTTPPost("urunKaydet",$bilgiler);
				if($response == ''){
					return array(
						'success'=>false,
						'hataKodu'=>'entego_api_baglanti_yok',
						'mesaj'=>'Entego API ile bağlantı sağlanamadı, lütfen daha sonra tekrar deneyiniz.',
					);
				}
				$cevap = json_decode($response);

				$sonuc = $cevap;
				/** Ürün başarıyla kayıt edilirse Veritabanına N11 ID ekleme BAŞLANGIÇ */
					if($sonuc->result->status == "success"){
						update_post_meta($id, 'n11urunId', $sonuc->product->id);
						update_post_meta($id, 'n11ProductSellerCode', 'N11-PR-'.$id);
						if(get_option('entego_n11_autosave') == 'true'){
							if(!get_post_meta($id,'urunN11OtomatikGuncelle',false)){
								update_post_meta($id, 'urunN11OtomatikGuncelle','true');
							}
						}
						//Hata olarak kayıtlıysa silmek için fonksiyon
						$this->hataVarmiKontrol($id);
						return array(
							'success'=>true,
							'mesaj'=>'Ürün başarıyla n11\'e gönderildi.',
							'hataKodu'=>'basarili',
							'urunBilgileri'=>@$urunBilgileri,
							'urunSonuc'=>$sonuc
						);
					}elseif($sonuc->result->errorCode == 'SELLER_API.mandatoryAttributesInvalid'){
						$tt = explode(" Özellik Adı : ",$sonuc->result->errorMessage);
						$tt = explode(",",$tt[1]);
						$nitelik = $tt[0];
						$sonuc = array(
							'success'=>false,
							'hataKodu'=>'hatali_ozellik',
							'zorunluNitelik'=>$nitelik,
							'mesaj'=>'Girmiş olduğunuz ürün özelliklerinden(Nitelikler) "'.$nitelik.'" hatalı olan mevcut lütfen tekrar kontrol ediniz.');
						return $sonuc;
					}elseif($sonuc->result->errorCode == 'PRODUCT.seller.prohibited.categorygroup'){
						return array(
							'success'=>false,
							'mesaj'=>$cevap->result->errorMessage,
							'hataKodu'=>'n11_kategori_yetkisi_yok',
						);
					}elseif($sonuc->reuslt->errorCode == 'GTIN.gtinIsNotExists'){
						return array(
							'success'=>false,
							'mesaj'=>$cevap->result->errorMessage,
							'hataKodu'=>'gtin_yok_veya_gecersiz',
						);
					}else {
						if(isset($cevap->result->errorMessage)){
							$mesaj = $cevap->result->errorMessage;
						}else {
							$mesaj = $cevap->mesaj;
						}
						return array(
							'success'=>false,
							'mesaj'=>$mesaj,
							'hataKodu'=>'n11_hatasi',
							'urunSonuc'=>$sonuc,
							'bilgiler'=>$bilgiler,
							'response'=>$response,
						); 
					}
				/** Ürün başarıyla kayıt edilirse Veritabanına N11 ID ekleme BİTİŞ */
				
			}

		}

		/**
		 * Tabloya Cron ürünü Ekle
		 * 
		 */
		public function cronUrunEkle($id){
			global $wpdb;
			$tabloAdi = $wpdb->prefix.'entego_n11_cron_urunler';
			$sorgu = $wpdb->get_row("SELECT * FROM $tabloAdi WHERE urun_id = $id");
			if($wpdb->num_rows<1){
				$data = array(
					'urun_id' => $id,
				);
				$wpdb->insert($tabloAdi,$data);
			}
		}

		/**
		 * Cron Tablosu Ürün Varlık Kontrolü
		 * 
		 */
		public function cronUrun($id){
			global $wpdb;
			$tabloAdi = $wpdb->prefix.'entego_n11_cron_urunler';
			$sorgu = $wpdb->get_row("SELECT * FROM $tabloAdi WHERE urun_id = '$id' LIMIT 1");
			return $sorgu;
		}

		/**
		 * Cronda Ürün Varmı Kontrol Et
		 * 
		 */
		public function urunKontrol(){
			$cronAdet = 10;// Her Cronda Kaç Ürün GÖnderimi Yapılmalı
			global $wpdb;

			$tabloAdi = $wpdb->prefix.'entego_n11_cron_urunler';
			$sorgu = $wpdb->get_results("SELECT * FROM $tabloAdi");
			if(count($sorgu) > 0){

				$adet = count($sorgu);
				if($adet > $cronAdet){
					$i = $cronAdet;
				}else {
					$i = $adet;
				}
				$a= 1;
				foreach($sorgu as $cron){
					$wpdb->delete($tabloAdi,array('urun_id'=>$cron->urun_id));
					$gonder = $this->N11Class_gonder($cron->urun_id);

						if($gonder['hataKodu'] == 'eksik_ozellik'){
						$this->hataKaydet($cron->urun_id,'zorunlu_nitelik',esc_html('Ürün otomatik olarak güncellenirken zorunlu olan özelliklerden eksik bulundu.','entego-n11'),'cron',1,1);
					}elseif($gonder['hataKodu'] == 'sablon_yok'){
						$this->hataKaydet($cron->urun_id,'sablon_yok',esc_html('Ürün kategori niteliklerinden eksik olanlar mevcut','entego-n11'),'cron',1,1);
					}elseif($gonder['hataKodu'] == 'kategori_yok'){
						$this->hataKaydet($cron->urun_id,'kategori_bulunamadi',esc_html('Ürün n11 kategorisi eşleştirilmemediği için gönderilmedi.','entego-n11'),'cron',1,1);
					}elseif($gonder['hataKodu'] == 'fazla_resim'){
						$this->hataKaydet($cron->urun_id,'urun_gorsel_sayisi_fazla',esc_html('Ürün Görsel Sayısı 12 den fazla olamaz.','entego-n11'),'cron',1,1);
					}elseif($gonder['hataKodu'] == 'basarili'){
						$this->hataKaydet($cron->urun_id,'urun_guncelleme_basarili',esc_html('Ürün Başarıyla N11\'de Güncellendi.','entego-n11'),'cron',2,1);
					}elseif($gonder['hataKodu'] == 'stok_yok'){
						$this->hataKaydet($cron->urun_id,'stok_yok',esc_html('Ürün Stokları tamamen tüklenmiş güncellemeniz gerekiyor.','entego-n11'),'cron',1,1);
					}elseif($gonder['hataKodu'] == 'hatali_ozellik'){
						$this->hataKaydet($cron->urun_id,'hatali_ozellik',
						sprintf(
							/* translators: %1$s: link to videos, %2$s: link to docs */
							__( 'Ürün N11\'e gönderilirken hata oluştu, "%1$s" değeri hatalı olarak girilmiş. Tekrar Kontrol ediniz.', 'entego-n11' ),
							$gonder['zorunluNitelik']
						)
						,'cron',1,1);
					}elseif($gonder['hataKodu'] == 'n11_kategori_yetkisi_yok'){
						$this->hataKaydet($cron->urun_id,'kategori_yetkisi_yok', esc_html('Ürün eklemeye çalıştığınız kategoriye ürün gönderme yetkiniz yoktur.','entego-n11'), 'cron', 1, 1);
					}elseif($gonder['urunSonuc']->result->errorMessage == 'Yetersiz Kredi'){
						$this->hataKaydet($cron->urun_id,'yetersiz_kredi', esc_html('Ürün Göndermek ve Silmek için kullanılan krediniz tükenmiş.','entego-n11'),'cron',1,1);
					}elseif($gonder['hataKodu'] == 'n11_hatasi'){
						$this->hataKaydet($cron->urun_id,'urun_guncelleme_basarisiz_n11_hatasi',esc_html('Ürün N11\'e gönderilken bir hata oluştu. - N11 Hata Mesajı','entego-n11').':'.$gonder['urunSonuc']->result->errorMessage,'cron',1,1);
					}elseif($gonder['hataKodu'] == 'gtin_yok_veya_gecersiz'){
						$this->hataKaydet(
						$cron->urun_id,'gtin_yok_veya_gecersiz',
						sprintf(
							/* translators: %1$s: link to videos, %2$s: link to docs */
							__( 'Bazı özel ürünlerde n11 tarafından GTIN kodu zorunlu kılınmıştır, GTIN kodu bulunamadı veya hatalı olarak girildi.  "%1$s"', 'entego-n11' ),
							'<a href="https://so.n11.com/selleroffice/product/gtinSearch" target="_blank">N11 GTIN Arama</a>'
						),'cron',1,1);
					}else{
						$this->hataKaydet($cron->urun_id,'bilinmeyen_hata',esc_html('Ürün N11\'e gönderilken bir hata oluştu. - N11 Hata Mesajı','entego-n11').':'.$gonder['urunSonuc']->result->errorMessage,'cron',1,1);
					}
					$a++;
					if($a>$i){
						die;
					}
				}
			}
		}

		/**
		 * Ürün Hata Kontrolü
		 * Eğer Hata Varsa Sil
		 * 
		 */
		public function hataVarmiKontrol($id){
			global $wpdb;
			$tabloAdi = $wpdb->prefix."entego_n11_hatalar";
			$sorgu = $wpdb->get_results("SELECT * FROM $tabloAdi WHERE post_id = $id");
			if($wpdb->num_rows > 0){
				$wpdb->delete($tabloAdi,array('post_id'=>$id));
			}
		}

		/**
		 * Ürün Stok Kontrol
		 * 
		 */
		public function stokKontrol($id){
			$products = wc_get_product($id);

			if($products->get_type() == 'simple'){
				$stok = $products->get_stock_quantity();
				if($stok < 1 ){
					return true;
				}else {
					return false;
				}
			}elseif($products->get_type() == 'variable'){
				$available_variations = $products->get_available_variations();
				$varyasyonSayisi = count($available_variations);
				$i = 0;
				foreach($available_variations as $taxonomy => $term_names){
					if($term_names["max_qty"] < 1){
						$i++;
					}
				}
				if($i == $varyasyonSayisi){
					return true;
				}else {
					return false;
				}
			}
		}

		/**
		 * Ürün Satın Alma Notu Ekleme
		 * Ürün Sonuçları Sayfasından gelen
		 * 
		 */
		public function urunNotEkle(){
			$post_id = sanitize_text_field($_POST['urun_id']);
			$nonce = sanitize_text_field($_POST['nonce']);
			$not = sanitize_text_field($_POST['not']);
			if(!wp_verify_nonce($nonce,'satin_alma_notu') || !isset($post_id) || !isset($not)){
				$sonuc = array(
					'sonuc'=>false,
					'mesaj'=>esc_html('Bağlantı doğrulamasında bir hata gerçekleşti, sayfayı yenileyip tekrar deneyiniz.','entego-n11')
				);
				wp_send_json($sonuc);
			}else {
				update_post_meta($post_id,'_purchase_note',$not);
				$gonder = $this->cronUrunEkle($post_id);
				$this->hataVarmiKontrol($post_id);
				wp_send_json(array(
					'sonuc'=>true,
					'mesaj'=>esc_html('Başarıyla kaydedildi ve Ürün Tekrar gönderilmek üzere sıraya alındı.','entego-n11')
				));
				
			}
		}

		/**
		 * Kategori eşleştirmesi yapılmamış ürünlerin kategori
		 * Sonuclar Sayfası AJAX
		 *
		 */
		public function sonuclar_kategori_ekle() {

			$nonce = sanitize_text_field($_POST['nonce']);
            $id 	= sanitize_text_field($_POST['post_id']);
            $kategori_id 	= sanitize_text_field($_POST['kategori_id']);
            $kategori_adi 	= sanitize_text_field($_POST['kategori_adi']);

			if( ! wp_verify_nonce( $nonce, 'sonuclar_kategori_esleme' ) || !isset($id) || !isset($kategori_adi) || !isset($kategori_id) ) {
				wp_send_json(array('sonuc'=>false,'mesaj'=>esc_html('İşlem gönderirken doğrulama kodu hatalı geldi, lütfen sayfayı yenileyip tekrar deneyiniz.','entego-n11')));
			}else {
                $up1 = update_post_meta($id,'n11Kategori_id',$kategori_id);
				$up2 = update_post_meta($id,'n11Kategori_adi',$kategori_adi);
				$this->hata_sil($id);
				$this->cronUrunEkle($id);
				$sonuc = array(
					'sonuc'=>true,
					'mesaj'=>esc_html('Eşleştirme başarıyla kayıt edildi.','entego-n11'),
					'id'=>$id
				);
				wp_send_json($sonuc);
			}
			
		}

		/**
		 * Sonuçlar sayfası Nitelikler Geri GÖnderme
		 * Sonuçlar AJAX
		 * 
		 */
		public function ozellik_gonder(){
			$nonce 			= sanitize_text_field($_POST['nonce']);
			$post_id 		= sanitize_text_field($_POST['post_id']);
			if(!wp_verify_nonce($nonce,'sonuclar_ozellik_getir')  || !isset($post_id)){
				wp_send_json(array(
					'sonuc'=>false,
					'mesaj'=>esc_html('Doğrulama kodunda hata oluştu, sayfayı yenilepip tekrar deneyiniz.','entego-n11')
				));
			}else {
				$n11Id = get_post_meta($post_id,'n11Kategori_id',true);
				$products = wc_get_product($post_id);
				$cevap = Entego_N11_Admin::ozelliklerDegerlerGetir($n11Id);
				if(!$cevap['sonuc']){
					if($cevap['mesaj']== 'entego_key_yok'){
						wp_send_json([
							'sonuc'=>false,
							'mesaj'=>esc_html('Ayarlar sayfasında eklenti api anahtarı ve api şifresini girerek kaydedip doğrulamanız gerekiyor.','entego-n11'),
						]);
					}elseif($cevap['mesaj']=='entego_baglanti_yok'){
						wp_send_json([
							'sonuc'=>false,
							'mesaj'=>esc_html('Entego API ile bağlantı sağlanamadı, daha sonra tekrar deneyiniz.','entego-n11'),
						]);
					}else {
						wp_send_json([
							'sonuc'=>false,
							'mesaj'=>$cevap['mesaj'],
						]);
					}
				}else {
					$cont = '';
					$cont .= '<input type="hidden" id="nitelikNonce" name="nitelikNonce" value="'.wp_create_nonce('nitelik_kayit_form').'">
					<input type="hidden" id="post_id" name="post_id" value="'.$post_id.'">';
					$ozellikler = $cevap['degerler'];
					foreach($ozellikler as $attri){
						if($attri->zorunluluk){$zor='<strong style="color:red;"> -'.esc_html('Zorunlu','entego-n11').'</strong>';}else {$zor=null;}
						$cont .= '
							<div style="margin:10px 0;" class="form-field form-required term-name-wrap">
								<label for="entegoN11Ozellik||'.$attri->nitelik_adi.'">'.$attri->nitelik_adi.' '.$zor.'</label>
								<select style="width:100%" name="entegoN11Ozellik||'.$attri->nitelik_adi.'" class="aramaSelect2" id="entego_n11_urun_attributes">
									<option value="">Seçim Yapınız</option>
						';
									foreach($attri->degerler as $deger){
										$selected = null;
									if(get_post_meta($post_id,'entegoN11Ozellik||'.$attri->nitelik_adi ,true) == $deger->deger.'||'.$deger->id){
										$selected = ' selected';
									}
						$cont .= '	<option value="'.$deger->deger.'||'.$deger->id.'"'.$selected.'>'.$deger->deger.'</option>';
									}
						$cont .='</select>
							</div>
						';
					}
					$cont .= '
					<br>
					<button style="float:left; width:24%;" class="button nitelikKaydet">'.esc_html('Kaydet','entego-n11').'</button>
					<br>
					<br>';
					wp_send_json([
						'sonuc'=>true,
						'content'=>$cont,
					]);
				}
			}
		}

		/**
		 * Nitelik Güncelleme
		 * Sonuçlar AJAX
		 * 
		 */
		public function nitelik_guncelle(){

			$nonce 		= sanitize_text_field($_POST['nonce']);
			$post_id 	= sanitize_text_field($_POST['post_id']);
            $data       = $_POST['data']; // This data is an array and the sequence is checked and checked in the loop.
			if(!wp_verify_nonce($nonce,'nitelik_kayit_form') || !isset($post_id) || !is_array($data)){
				wp_send_json(array(
					'sonuc'=>false,
					'mesaj'=>esc_html('Eksik veriler bulunmakta, sayfayı yenileyip tekrar deneyiniz.','entego-n11')
				));
			}else {
				$products = wc_get_product($post_id);
				$idler = [];
				foreach($data as $val){
					if($val['value'] != ''){
						$oz = explode('||',$val['name']);
						$idler[] = $oz[1];
						update_post_meta($post_id, $val['name'] , $val['value']);
					}
					update_post_meta($post_id, 'entegoN11Ozellikler' , implode(',',$idler));
				}
				$gonder = $this->cronUrunEkle($post_id);
						  $this->hataVarmiKontrol($post_id);
				wp_send_json(array(
					'sonuc'=>true,
					'mesaj'=>esc_html('Nitelikler başarıyla güncellendi. Ürün tekrar sıraya alındı.','entego-n11')
				));
			}
		}

		/**
		 * Sonuçlar Sayfası Hata Silme
		 * Sonuçlar AJAX
		 */
		public function sonuclarHataSil(){
			$id 	= sanitize_text_field($_POST['id']);
			$nonce  = sanitize_text_field($_POST['nonce']);
			if(!wp_verify_nonce($nonce,'sonuclar_hata_sil') || !isset($id)){
				wp_send_json(array(
					'sonuc'=>false,
					'mesaj'=>esc_html('Eksik bilgiler ulaştı, sayfayı yenileyip tekrar deneyiniz.','entego-n11')
				));
			}else {
				$this->hata_sil($id);
				wp_send_json(array(
					'sonuc'=>true,
				));
			}


		}

		/**
		 * Hatalar Tablosu Hata Silme Fonksiyonu
		 * 
		 */
		public function hata_sil($id){
			global $wpdb;
			$tabloAdi = $wpdb->prefix."entego_n11_hatalar";
			$delete = $wpdb->delete($tabloAdi,array('id'=>$id));
			return true;
		}

		/**
		 * Sonuçlar sayfası tekrar ürün sıraya alma butonu
		 * Sonuçlar AJAX
		 */
		public function sonuclar_ajax_tekrar_siraya_al(){
			$nonce 		= sanitize_text_field($_POST['nonce']);
			$id			= sanitize_text_field($_POST['id']);
			if(!wp_verify_nonce($nonce,'entego_n11_tekrar_siraya_al') || !isset($id)){
				wp_send_json([
					'sonuc'=>false,
					'mesaj'=>esc_html('Eksik bilgiler ulaştıı işlem gerçekleştirilemedi.','entego-n11'),
				]);
			}
			$this->cronUrunEkle($id);
			wp_send_json([
				'sonuc'=>true,
				'mesaj'=>esc_html('Başarıyla tekrar sıraya alındı.','entego-n11'),
			]);
		}
		
		/**
		 * Ürünler Sayfası Kategoriler Arama ve Eşleştirme
		 * AJAX İşlemi
		 * 
		 */
		public function ajax_kategori_sorgula(){

			$nonce  = sanitize_text_field($_POST['nonce']);
			$search = sanitize_text_field($_POST['search']);
			if(wp_verify_nonce($nonce,"entego_n11_kategori_ara") && isset($search)){
				$response = Entego_N11_Admin::kategoriSorgulama($search);
				if(!$response['sonuc']){
					if($response['mesaj']== 'entego_key_yok'){
						wp_send_json([
							'sonuc'=>false,
							'mesaj'=>esc_html('Sistem pasif durumda ayarlar sayfasından api anahtarlarınızı kontrol ederek yeniden kaydetmelisiniz.','entego-n11'),
						]);
					}elseif($response['mesaj'] == 'entego_baglanti_yok'){
						wp_send_json([
							'sonuc'=>false,
							'mesaj'=>esc_html('Entego API ile bağlantı sağlanamadı, lütfen daha sonra tekrar deneyiniz.','entego-n11'),
						]);
					}else {
						wp_send_json([
							'sonuc'=>false,
							'mesaj'=>$response['mesaj'],
						]);
					}
				}else {
					wp_send_json($response);
				}
			}else {
				wp_send_json([
					'sonuc'=>false,
					'mesaj'=>esc_html('Eksik veriler olduğu için işleminiz gerçekleştirlemedi','entego-n11'),
				]);
			}

		}


		/**
		 * Ürün Düzenleme Sayfasında
		 * Ürün Gönder Butonuna Tıklayınca 
		 * Option Oluşturma
		 * 
		 */
		public function entego_n11_urun_kaydetme(){
			$nonce = sanitize_text_field($_POST['nonce']);
			$id = sanitize_text_field($_POST['id']);
			if(!wp_verify_nonce($nonce,"entego_n11_urun_kaydetme") || !isset($id)){
				wp_send_json([
					'sonuc'=>false,
					'mesaj'=>'Eksik veri bulunmakta, lütfen sayfayı yenileyip tekrar deneyiniz.',
				]);
			}

			update_post_meta($id,'entegoN11UrunGondermeButon',true);
			wp_send_json([
				'sonuc'=>true,
				'mesaj'=>'Başarıyla sıraya alındı',
			]);
		}

		/**
		 * Ürüne Kayıt Edilen N11 Özellikleri
		 * Return Etme
		 */
		public function entego_n11_ozellikler_gonder($urunId){
			$ozellikler = get_post_meta($urunId,'entegoN11Ozellikler',true);
			$degerler = [];
			if(isset($ozellikler) && count(explode(',',$ozellikler))> 0 && $ozellikler != ''){
				$ozellikler = explode(',',$ozellikler);
				foreach($ozellikler as $ozellik){
					$deger = explode("||",get_post_meta($urunId,'entegoN11Ozellik||'.$ozellik, true));
					$degerler[] = [
						'adi'=>$ozellik,
						'deger'=>$deger[0],
						'deger_id'=>$deger[1],
					];
				}
			}elseif(isset($ozellikler) && $ozellikler != ''){
				$ozellikler = [$ozellikler];
				$deger = explode("||",get_post_meta($urunId,'entegoN11Ozellik||'.$ozellikler, true));
				$degerler[] = [
					'adi'=>$ozellikler,
					'deger'=>$deger[0],
					'deger_id'=>$deger[1],
				];
			}else{
				return false;
			}
			return [
				'ozellikler'=>$ozellikler,
				'degerler'=>$degerler,
			];
		}

	}
?>