<?php
//Bu dosya doğrudan çağrılırsa iptal edin.
if ( ! defined( 'WPINC' ) ) {
	die;
}

/**
 * Eklenti için yönetici alanı görünümü sağlama
 *
 * Bu dosya, eklentinin yöneticiye bakan yönlerini işaretlemek için kullanılır.
 *
 * @since      1.0.0
 *
 * @package    Entoge_N11
 * @subpackage Entego_N11/admin/partials
 */
global $wpdb;
$katName = $wpdb->prefix.'entego_n11_kategoriler'; $termName = $wpdb->prefix.'terms';
$adet = $wpdb->get_row("SELECT COUNT(id) as sayi FROM $katName INNER JOIN $termName ON $katName.woocommerce_kategori_id = $termName.term_id");
?>

<!-- Bu dosya öncelikle biraz PHP içeren HTML'den oluşmalıdır. -->
<hr class="wp-header-end">
<div id="col-container" class="wp-clearfix">
    <div id="col-left">
        <div class="col-wrap">
            <p><?=esc_html('WooCommerce üzerindeki ürünlerinizini koordine bir şekilde gönderebilmek için kategori eşleştirmesi gerekiyor.','entego-n11')?></p>
            <p><?=esc_html('Kategori eşleştirmelerini ürün düzeleme sayfasında yapabileceğiniz gibi belli bir kategorideki tüm ürünlerede aynı anda yapabilirsiniz.','entego-n11')?></p>
            <p><?=esc_html('Aşşağıda belirteceğiniz kategoriye n11\'den seçeceğiniz kategori tüm ürünlere atanacaktır.','entego-n11')?></p>
            <p><?=esc_html('Öncelikle WooCommerce kategorisi seçmelisiniz, daha sonra Seçmiş olduğunuz kategoriye uygun olanlardan seçim yapabilirsiniz.','entego-n11')?></p>
        <div class="form-wrap">
            <h2><?=esc_html('Kategori Eşleştir','entego-n11')?></h2>
            <form id="kategoriEkle" method="post" action="<?php echo admin_url( 'admin-ajax.php' ); ?>" class="validate">
                <div class="form-field form-required term-name-wrap">
                    <label for="wooKategori"><?=esc_html('WooCommerce Kategorisi Seçiniz.','entego-n11')?></label>
                        <?php
						$taxonomies = get_terms( array(
							'taxonomy' => 'product_cat',
							'hide_empty' => false
						) );
						
						if ( !empty($taxonomies) ) :
							$output = '<select id="wooKategori" name="wooKategori" class="wc-enhanced-select" required>'."\r\n";
							
							$output.= '<option value="0" >'.esc_html('Seçim Yapınız','entego-n11').'</option>'."\r\n";
							foreach( $taxonomies as $category ) {
                                if(!Entego_N11_Admin::kategoriKontrol($category->term_id)){
                                    $output.= '<option value="'.$category->term_id.'">'. esc_html( $category->name ) .'</option>'."\r\n";
                                }
							}
							$output.='</select>';
							echo $output;
						endif;
					    ?>
                </div>
                <?php
                if(get_option('entego_n11_aktif') != 1){
                    echo '<p style="color:red">'.esc_html('Api Anahtarı ve Api Şifresi henüz doğrulanmamış, Eklenti > Ayarlar sayfasından tekrar kayıt ediniz.','entego-n11').'</p>';
                }else {
                ?>

                        <div class="form-field form-required term-name-wrap kategoriOnerileri">
                            <label><?=esc_html('Kategori Önerileri','entego-n11')?></label>
                            <div class="oneriSonuc"></div>
                        </div>

                        <div class="form-field term-display-type-wrap">
                            
                            <label class="lKategoriArama" for="kategoriArama">Kategori Arama</label>
                            <select placeholder="Aramak için tıklayınız." name="kategoriArama" id="kategoriArama" class="wc-enhanced-select-init kategoriArama select2" disabled>
                                <option value="">Kategori Arama..</option>
                            </select>
                        </div>

                        <p class="submit">
                            <input type="submit" name="submit" id="submit" class="kategoriEkleBtn button button-primary" value="<?=esc_html('Yeni kategori ekle','entego-n11')?>">
                            <span class="spinner"></span>
                        </p>

                <?php
                }
                ?>
            </form>
        </div>
    </div>
</div>

<div id="col-right">
    <div class="col-wrap">

        <h2><?=esc_html('Eşleştirilmiş Kategoriler','entego-n11')?></h2>

        <form id="posts-filter" method="post">
            <div class="tablenav top">

            <div class="alignleft actions bulkactions">
                <label for="bulk-action-selector-top" class="screen-reader-text"><?=esc_html('Toplu eylem seçin','entego-n11')?></label>
                <select name="action" id="bulk-action-selector-top">
                    <option value="-1"><?=esc_html('Toplu İşlemler','entego-n11')?></option>
                    <option value="delete"><?=esc_html('Sil','entego-n11')?></option>
                </select>
                <input type="submit" id="doaction" class="button action" value="<?=esc_html('Uygula','entego-n11')?>">
            </div>
        
            <div class="tablenav-pages one-page">
                <span class="displaying-num"><?=$adet->sayi?> öge</span>
                <span class="pagination-links">
                    <span class="tablenav-pages-navspan button disabled" aria-hidden="true">«</span>
                    <span class="tablenav-pages-navspan button disabled" aria-hidden="true">‹</span>
                    <span class="paging-input">
                    <label for="current-page-selector" class="screen-reader-text"><?=esc_html('Geçerli sayfa','entego-n11')?></label>
                    <input class="current-page" id="current-page-selector" type="text" name="paged" value="1" size="1" aria-describedby="table-paging">
                    <span class="tablenav-paging-text"> / 
                        <span class="total-pages">1</span>
                    </span>
                </span>

                <span class="tablenav-pages-navspan button disabled" aria-hidden="true">›</span>
                <span class="tablenav-pages-navspan button disabled" aria-hidden="true">»</span></span></div>
                <br class="clear">
            </div>

        <h2 class="screen-reader-text"><?=esc_html('Kategori listesi','entego-n11')?></h2>
        <table class="wp-list-table widefat fixed striped tags ui-sortable">
            <thead>
                <tr>
                    <td id="cb" class="manage-column column-cb check-column">
                        <label class="screen-reader-text" for="cb-select-all-1"><?=esc_html('Tümünü seç','entego-n11')?></label>
                        <input id="cb-select-all-1" type="checkbox">
                    </td>
                    <th style="width:30%;" scope="col" id="name" class="manage-column column-name column-primary sortable desc">
                        <a href="#">
                            <span><?=esc_html('İsim','entego-n11')?></span>
                            <span class="sorting-indicator"></span>
                        </a>
                    </th>
                    <th style="width:60%;text-align:left;" scope="col" id="description" class="manage-column column-description sortable desc">
                        <span><?=esc_html('N11 Kategorisi','entego-n11')?></span>
                    </th>
                    <th style="width:10%;" scope="col" id="posts" class="manage-column column-posts num sortable desc">
                        <span><?=esc_html('Toplam','entego-n11')?></span>
                    </th>
                    <th scope="col" id="handle" class="manage-column column-handle" style="display: table-cell;"></th>
                </tr>
            </thead>

            <tbody id="the-list" data-wp-lists="list:tag">
                <?php
                if($adet->sayi < 1){
                ?>
                    <tr>
                        <td></td>
                        <td><?=esc_html('Henüz hiç eşleştirme yapılmamış.','entego-n11')?></td>
                        <td></td>
                        <td></td>
                    </tr>
                <?php
                }
                    foreach($taxonomies as $val){
                    $katTabName = $wpdb->prefix.'entego_n11_kategoriler';
                    $katId = $val->term_id;
                    $kontrol = $wpdb->get_row("SELECT * FROM $katTabName WHERE woocommerce_kategori_id = '$katId'");
                    if($wpdb->num_rows > 0){
                ?>
                    <tr id="tag-<?=$val->term_id?>">
                        <th scope="row" class="check-column">
                            <label class="screen-reader-text" for="cb-select-<?=$kontrol->woocommerce_kategori_id?>">Seç <?=$kontrol->woocommerce_kategori_id?></label>
                            <input type="checkbox" name="delete_tags[]" value="<?=$kontrol->woocommerce_kategori_id?>" id="cb-select-<?=$kontrol->woocommerce_kategori_id?>">
                        </th>
                        <td class="name column-name has-row-actions column-primary" data-colname="<?=esc_html('İsim','entego-n11')?>">
                            <strong>
                                <a class="row-title" href="#" aria-label="“<?=$val->name?>” (<?=esc_html('Düzenle','entego-n11')?>)"><?=$val->name?></a>
                            </strong>
                            <br>
                            <div class="row-actions">
                                <!--<span class="edit"><a class="kategoriDuzenle" href="#" data-id="<?=$kontrol->woocommerce_kategori_id;?>" aria-label="“<?=$val->name?>” Düzenle">Düzenle</a> | </span>-->
                                <span class="delete"><a href="#" data-id="<?=$kontrol->woocommerce_kategori_id;?>" class="kategoriSil delete-tag aria-button-if-js" aria-label="“<?=$val->name?>” terimini sil" role="button"><?=esc_html('Sil','entego-n11')?></a> </span>
                            </div>
                        </td>
                        <td class="name column-name has-row-actions column-primary">
                            <strong>
                            <?php
                            echo $kontrol->n11Kategori;
                            ?>
                            </strong>
                        </td>
                        <td class="posts column-posts" data-colname="Toplam">
                            <?=$val->count?>
                        </td>
                        <td class="handle column-handle ui-sortable-handle" data-colname="" style="display: table-cell;">
                            <input type="hidden" name="term_id" value="<?=$val->term_id?>">
                        </td>
                    </tr>
                <?php
                    }
                    }
                ?>
            </tbody>

            <tfoot>
                <tr>
                 <td id="cb" class="manage-column column-cb check-column">
                        <label class="screen-reader-text" for="cb-select-all-1"><?=esc_html('Tümünü seç<','entego-n11')?>/label>
                        <input id="cb-select-all-1" type="checkbox">
                    </td>
                    <th scope="col" id="name" class="manage-column column-name column-primary sortable desc">
                        <a href="#">
                            <span><?=esc_html('İsim','entego-n11')?></span>
                            <span class="sorting-indicator"></span>
                        </a>
                    </th>
                    <th scope="col" id="description" class="manage-column column-description sortable desc">
                        <span><?=esc_html('N11 Kategorisi','entego-n11')?></span>
                    </th>
                    <th scope="col" id="posts" class="manage-column column-posts num sortable desc">
                        <span><?=esc_html('Toplam','entego-n11')?></span>
                    </th>
                    <th scope="col" id="handle" class="manage-column column-handle" style="display: table-cell;"></th>
                </tr>
            </tfoot>
        </table>

        <div class="tablenav bottom">
            <div class="alignleft actions bulkactions">
                <label for="bulk-action-selector-bottom" class="screen-reader-text"><?=esc_html('Toplu eylem seçin','entego-n11')?></label>
                <select name="action2" id="bulk-action-selector-bottom">
                    <option value="-1"><?=esc_html('Toplu İşlemler','entego-n11')?></option>
                    <option value="delete"><?=esc_html('Sil','entego-n11')?></option>
                </select>
                <input type="submit" id="doaction2" class="button action" value="<?=esc_html('Uygula','entego-n11')?>">
            </div>

            <div class="tablenav-pages one-page">
                <span class="displaying-num"><?=$adet->sayi?> öge</span>
                <span class="pagination-links">
                    <span class="tablenav-pages-navspan button disabled" aria-hidden="true">«</span>
                    <span class="tablenav-pages-navspan button disabled" aria-hidden="true">‹</span>
                    <span class="screen-reader-text"><?=esc_html('Geçerli sayfa','entego-n11')?></span>
                    <span id="table-paging" class="paging-input">
                        <span class="tablenav-paging-text">1 / 
                            <span class="total-pages">1</span>
                        </span>
                    </span>
                    <span class="tablenav-pages-navspan button disabled" aria-hidden="true">›</span>
                    <span class="tablenav-pages-navspan button disabled" aria-hidden="true">»</span>
                </span>
            </div>
            <br class="clear">
        </div>
            
    </form>
        </div>
    </div><!-- /col-right -->

</div><!-- /col-container -->
