<?php
//Bu dosya doğrudan çağrılırsa iptal edin.
if ( ! defined( 'WPINC' ) ) {
	die;
}

/**
 * Eklenti için yönetici alanı görünümü sağlama
 *
 * Bu dosya, eklentinin yöneticiye bakan yönlerini işaretlemek için kullanılır.
 *
 * @since      1.0.0
 *
 * @package    Entoge_N11
 * @subpackage Entego_N11/admin/partials
 */
$url = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";

$key        = get_option('entego_n11_api_key');
$key2       = get_option('entego_n11_api_secret_key');
$entego_key = get_option('entego_n11_key');
if($entego_key == ''){
    $hata = 'Ayarlar sayfasından api anahtarı ve api şifresinizi tekrar girip onaylamanız gerekmektedir.';
}

$response = Entego_N11_Baglanti::HTTPPost("siparislerGetir", array(
    'api_key' => $key,
    'api_secret_key' => $key2,
    'alan_adi'	=> get_site_url(),
    'entego_key' => $entego_key,
));
if($response == ''){
    $hata = 'Entego API ile bağlantı sağlanamadı, daha sonra tekrar deneyiniz.';
}
$sonuc = json_decode($response);
//print_r($sonuc);
?>

<!-- Bu dosya öncelikle biraz PHP içeren HTML'den oluşmalıdır. -->
<div class="wrap">
    <h1 class="wp-heading-inline">Siparişler</h1>
    <hr class="" id="wp__notice-list-uncollapsed">
    <?php
        if($hata){
            echo $hata;
        }
        
        
    if(!$hata){?>
        <div class="updated notice">
            <p>Bu sayfada sadece son 2 günlük kayıtlar listelenmektedir.</p>
        </div>
        <input type="hidden" name="page" class="post_status_page" value="entego_n11_siparisler">

        <table class="siparislerTablo widefat fixed">
            <thead>
                <tr>
                    <th class="manage-column column-cevap sortable " style="width:10%" scope="col">
                    <?=esc_html('Sipariş Numarası','entego-n11')?> <br><?=esc_html('Tarih','entego-n11')?> 
                    </th>
                    <th class="manage-column column-cevap sortable " style="width:50px;text-align:center"  scope="col"><?=esc_html('Sipariş Durum','entego-n11')?></th>
                    <th class="manage-column column-date sortable" style="width:25%"  scope="col">
                        <span><?=esc_html('Ürün Adı','entego-n11')?> / <?=esc_html('Birim Fiyatı','entego-n11')?></span>
                    </th>
                    <th class="manage-column column-date sortable" style="width:15%;text-align:center;"  scope="col"><?=esc_html('Ürün Adedi','entego-n11')?><br><?=esc_html('N11 Komisyonu','entego-n11')?></th>
                    <th class="manage-column column-date sortable" style="width:7%;text-align:center;"  scope="col"><?=esc_html('Ödeme Tipi','entego-n11')?></th>
                    <th class="manage-column column-date sortable" style="width:7%;text-align:center;"  scope="col"><?=esc_html('Toplam Tutar','entego-n11')?></th>
                </tr>
            </thead>
            <tfoot>
            <tr>
                    <th class="manage-column column-cevap sortable " style="width:10%" scope="col">
                    <?=esc_html('Sipariş Numarası','entego-n11')?> <br> <?=esc_html('Tarih','entego-n11')?>
                    </th>
                    <th class="manage-column column-cevap sortable " style="width:50px;text-align:center"  scope="col"><?=esc_html('Sipariş Durum','entego-n11')?></th>
                    <th class="manage-column column-date sortable" style="width:25%"  scope="col">
                        <span><?=esc_html('Ürün Adı','entego-n11')?> / <?=esc_html('Birim Fiyatı','entego-n11')?></span>
                    </th>
                    <th class="manage-column column-date sortable" style="width:15%;text-align:center;"  scope="col"><?=esc_html('Ürün Adedi','entego-n11')?><br><?=esc_html('N11 Komisyonu','entego-n11')?></th>
                    <th class="manage-column column-date sortable" style="width:7%;text-align:center;"  scope="col"><?=esc_html('Ödeme Tipi','entego-n11')?></th>
                    <th class="manage-column column-date sortable" style="width:7%;text-align:center;"  scope="col"><?=esc_html('Toplam Tutar','entego-n11')?></th>
                </tr>
            </tfoot>
            <tbody id="the-list">
                <?php
                if(!isset($sonuc->siparisler)){
                    echo '
                    <tr>
                        <th>'.esc_html('Sipariş Bulunamadı','entego-n11').'</tg>
                    </tr>
                    ';
                }else {
                    foreach($sonuc->siparisler as $siparis){
                        // Sİpariş DUurmu
                            $st = $siparis->status;
                            if($st == 1){
                                $status = esc_html('İşlem Bekliyor','entego-n11');
                            }elseif($st == 2){
                                $status = esc_html('Ödendi','entego-n11');
                            }elseif($st == 3){
                                $status = esc_html('Geçersiz','entego-n11');
                            }elseif($st == 4){
                                $status = esc_html('İptal Edilmiş','entego-n11');
                            }elseif($st == 5){
                                $status = esc_html('Kabul Edilmiş','entego-n11');
                            }elseif($st == 6){
                                $status = esc_html('Kargoda','entego-n11');
                            }elseif($st == 7){
                                $status = esc_html('Teslim Edilmiş','entego-n11');
                            }elseif($st == 8){
                                $status = esc_html('Reddedilmiş','entego-n11');
                            }elseif($st == 9){
                                $status = esc_html('İade Edildi','entego-n11');
                            }elseif($st == 10){
                                $status = esc_html('Tamamlandı','entego-n11');
                            }elseif($st == 11){
                                $status = esc_html('İade İptal Değişim Talep Edildi','entego-n11');
                            }elseif($st == 12){
                                $status = esc_html('İade İptal Değişim Tamamlandı','entego-n11');
                            }elseif($st == 13){
                                $status = esc_html('Kargoda İade','entego-n11');
                            }elseif($st == 14){
                                $status = esc_html('Kargo Yapılması Gecikmiş','entego-n11');
                            }elseif($st == 15){
                                $status = esc_html('Kabul Edilmiş Ama Zamanında Kargoya Verilmemiş','entego-n11');
                            }elseif($st == 16){
                                $status = esc_html('Teslim Edilmiş İade','entego-n11');
                            }elseif($st == 17){
                                $status = esc_html('Tamamlandıktan Sonra İade','entego-n11');
                            }
                        //#Sipariş Durumu
                        // Ödeme Yönetimi
                            $pt = $siparis->paymentType;
                            if($pt == 1){
                                $odeme = esc_html('Kredi Kartı','entego-n11');
                            }elseif($pt == 2){
                                $odeme = esc_html('BKMEXPRESS','entego-n11');
                            }elseif($pt == 3){
                                $odeme = esc_html('AKBANKDIRECT','entego-n11');
                            }elseif($pt == 4){
                                $odeme = esc_html('PAYPAL','entego-n11');
                            }elseif($pt == 5){
                                $odeme = esc_html('MallPoint','entego-n11');
                            }elseif($pt == 6){
                                $odeme = esc_html('GARANTIPAY','entego-n11');
                            }elseif($pt == 7){
                                $odeme = esc_html('GarantiLoon','entego-n11');
                            }elseif($pt == 8){
                                $odeme = esc_html('MasterPass','entego-n11');
                            }elseif($pt == 9){
                                $odeme = esc_html('ISBANKPAY','entego-n11');
                            }elseif($pt == 10){
                                $odeme = esc_html('PAYCELL','entego-n11');
                            }elseif($pt == 11){
                                $odeme = esc_html('COMPANY','entego-n11');
                            }elseif($pt == 12){
                                $odeme = esc_html('YKPAY','entego-n11');
                            }elseif($pt == 13){
                                $odeme = esc_html('Diğer','entego-n11');
                            }
                        //#Odeme Yönetimi
                        if(isset($siparis->orderItemList->orderItem->id)){
                            $sorgu = $siparis->orderItemList;
                        }else {
                            $sorgu = $siparis->orderItemList->orderItem;
                        }
                        $urunAdi = [];
                        $komisyon = [];
                        $adet = [];
                        $birimFiyat = [];
                        foreach($sorgu as $urun){
                            $urunAdi[] = $urun->productName;
                            $komisyon[] = number_format($urun->commission,2);
                            $adet[] = $urun->quantity;
                            $birimFiyat[] = number_format($urun->price,2);
                        }
                        $urunAdlari = implode("<br>", $urunAdi);
                        $urunFiyat = implode("<br>",$birimFiyat);
                        $adet = implode("<strong> - </strong>",$adet);
                        $komisyon = implode("<strong> - </strong>",$komisyon);
                        ?>
                        <tr>
                            <th><?=$siparis->orderNumber?> <br> <?=$siparis->createDate?></th>
                            <th style="text-align:center;"><?=$status?></th>
                            <th><?php print_r($urunAdlari);?> <br><strong>Fiyatlar:</strong> <?=$urunFiyat?></th>
                            <th style="text-align:center;"><?=$adet?> <br> <?=$komisyon?></th>
                            <th style="text-align:center;"><?=$odeme?></th>
                            <th style="text-align:center;"><strong><?=number_format($siparis->totalAmount,2)?> ₺</strong></th>
                        </tr>
                        <?php
                    }
                }
                ?>
            </tbody>
        </table>
    <?php } ?>
</div>