<?php
//Bu dosya doğrudan çağrılırsa iptal edin.
if ( ! defined( 'WPINC' ) ) {
	die;
}

/**
 * Eklentinin devre dışı bırakılması sırasında kullanılır
 *
 *
 * @package    Entego_N11
 * @subpackage Entego_N11/includes
 */

/**
 * Eklentinin devre dışı bırakılması sırasında kullanılır
 *
 * Bu sınıf, eklentinin devre dışı bırakılması sırasında çalışması için gereken tüm kodu tanımlar.
 *
 * @since      1.0.0
 * @package    Entego_N11
 * @subpackage Entego_N11/includes
 */
class Entego_N11_Deactivator {

	/**
	 * Kısa Açıklama. (kullanım süresi)
	 *
	 * Uzun Açıklama.
	 *
	 * @since    1.0.0
	 */
	public static function deactivate() {
		Entego_N11_Deactivator::eklenti_etkisizlestirildi();
	}


	/**
	 * EKlenti etkisizleştirme durumunda istek atma
	 * 
	 */
	public function eklenti_etkisizlestirildi(){
		$durum = 'Eklenti etkisizleştirildi.';

		$key        = get_option('entego_n11_api_key');
		$key2       = get_option('entego_n11_api_secret_key');
		$entego_key = get_option('entego_n11_key');
		if(!$key){
			$key = 11;
		}
		if(!$key2){
			$key = 11;
		}
		if(!$entego_key){
			$entego_key = 11;
		}

		$args = array(
            'body' => [
				'api_key' => $key,
				'api_secret_key' => $key2,
				'alan_adi'	=> get_site_url(),
				'entego_key' => $entego_key,
				'durum'=>$durum,
				'version'=>ENTEGO_N11_VERSION,
			],
            'timeout' => '120',
            'redirection' => '5',
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => array(),
            'cookies' => array()
        );
        $response = wp_remote_post('https://api.entego.com.tr/api/n11/eklentiAktiflesti', $args );
	}

}
